/*!
 ***********************************************************************
 \par Copyright
 \verbatim
  ________  _____           _____   _____           ____  ____   ____		
     /     /       /       /       /       /     /   /    /   \ /			
    /     /___    /       /___    /       /____ /   /    /____/ \___			
   /     /       /       /       /       /     /   /    /           \		
  /     /_____  /_____  /_____  /_____  /     / _ /_  _/_      _____/ 		
   																				
  Copyright (c) 2009 Telechips Inc.
  Korad Bldg, 1000-12 Daechi-dong, Kangnam-Ku, Seoul, Korea					
 \endverbatim
 ***********************************************************************
 */
/*!
 ***********************************************************************
 *
 * \file
 *		cdk_audio.h
 * \date
 *		2009/06/25
 * \author
 *		Jonathan-Kim(AValgorithm@telechips.com)
 * \brief
 *		cdk audio
 * \version
 *		- 0.0.1 : 2009/06/25
 *
 ***********************************************************************
 */
#ifndef _CDK_AUDIO_H_
#define _CDK_AUDIO_H_
#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************/
/*						                                                */
/* CDK Audio Funcs		                                                */
/*						                                                */
/************************************************************************/
cdk_result_t 
cdk_adec_init( cdk_core_t* pCdk, cdmx_info_t *pCdmxInfo, int iAdecType, int iCtype);
cdk_result_t 
cdk_adec_decode( cdk_core_t* pCdk, cdmx_info_t *pCdmxInfo, cdmx_output_t *pCdmxOut, int iAdecType,int iSeekFlag ,unsigned char *pOutBuffer,unsigned int *OutLen );
cdk_result_t 
cdk_adec_decode2( cdk_core_t* pCdk, cdmx_output_t *pCdmxOut, int iAdecType, int iSeekFlag, unsigned char *pOutBuffer,
	unsigned int *OutLen,int dynamic_mode,int outputmode );
cdk_result_t 
cdk_adec_close( cdk_core_t* pCdk );
cdk_result_t 
cdk_aenc_init( cdk_core_t* pCdk, cmux_info_t *pCmuxInfo, int iAencType, int iCtype);
cdk_result_t 
cdk_aenc_encode( cdk_core_t* pCdk, cmux_info_t *pCmuxInfo, cmux_input_t *pCdmxInput, int iAencType );
cdk_result_t 
cdk_aenc_close( cdk_core_t* pCdk );

int	cdk_aenc_get_readcnt(void);
cdk_result_t cdk_aenc_encode_app( cdk_core_t* pCdk, unsigned char *input_buf, unsigned char *output_buf);
cdk_result_t cdk_aenc_close_app( cdk_core_t* pCdk, unsigned char* hader_data, long file_pos );

/************************************************************************/
/*						                                                */
/* CDK Audio Defines	                                                */
/*						                                                */
/************************************************************************/

#define AUDIO_ID_AAC 0
#define AUDIO_ID_MP3 1
#define AUDIO_ID_AMR 2
#define AUDIO_ID_AC3 3
#define AUDIO_ID_A52 3

//#define AUDIO_ID_PCM 4	//--> WAV
#define AUDIO_ID_MP3HD 4
#define AUDIO_ID_MP2 5
#define AUDIO_ID_DTS 6
#define AUDIO_ID_QCELP 7
#define AUDIO_ID_AMRWBP 8
#define AUDIO_ID_WMA 9
#define AUDIO_ID_EVRC 10
#define AUDIO_ID_FLAC 11
#define AUDIO_ID_COOK 12
#define AUDIO_ID_G722 13
#define AUDIO_ID_G729 14
#define AUDIO_ID_APE 15
//#define AUDIO_ID_MSADPCM 16	//--> WAV
#define AUDIO_ID_WAV 16
//#define AUDIO_ID_IMAADPCM 17	//--> WAV
#define AUDIO_ID_DRA 17
#define AUDIO_ID_VORBIS 18
#define AUDIO_ID_BSAC 19

#define AUDIO_ID_MP1  20
#define AUDIO_ID_DDP  21
#define AUDIO_ID_TRUEHD  23

#define AUDIO_SIZE_MAX ((4608 * 2)*8*2 )	
#define AC3_BUFFER_SIZE		(1024*50)
#define AUDIO_MAX_INPUT_SIZE	(1024*96)

#define AUDIO_ERROR_THRESHOLD	1000

#define AUDIO_DECODING	0x10
#define AUDIO_ENCODING	0x20


#define CDK_AUDIO_RESERVED	0

// encoder subtype  .
#define ENC_PCM_TYPE	1
#define ENC_MS_ADPCM	2
#define ENC_A_LAW		6
#define ENC_MU_LAW		7
#define ENC_IMA_ADPCM	11
/************************************************************************

				Audio Decoder List
				
*************************************************************************/
#ifdef INCLUDE_AAC_DEC
#define AAC_DECODER	TCC_AAC_DEC
#else
#define AAC_DECODER	0
#endif

#ifdef INCLUDE_MP3_DEC
#define MP3_DECODER	TCC_MP3_DEC
#else
#define MP3_DECODER	0
#endif

#ifdef INCLUDE_ARMNB_DEC
#define AMRNB_DECODER	TCC_AMRNB_DEC
#else
#define AMRNB_DECODER	0
#endif

#ifdef INCLUDE_AC3_DEC
#define AC3_DECODER	TCC_AC3_DEC
#elif defined (INCLUDE_A52_DEC)
#define AC3_DECODER	TCC_A52_DEC
#else
#define AC3_DECODER	0
#endif

#ifdef INCLUDE_MP3HD_DEC
#define MP3HD_DECODER	TCC_MP3HD_DEC
#else
#define MP3HD_DECODER	0
#endif

#ifdef INCLUDE_MP2_DEC
#define MP2_DECODER	TCC_MP2_DEC
#else
#define MP2_DECODER	0
#endif

#ifdef INCLUDE_DTS_DEC
#define DTS_DECODER	TCC_DTS_DEC
#else
#define DTS_DECODER	0
#endif

#ifdef INCLUDE_QCELP_DEC
#define QCELP_DECODER	TCC_QCELP_DEC
#else
#define QCELP_DECODER	0
#endif

#ifdef INCLUDE_ARMWBPLUS_DEC
#define AMRWBPLUS_DECODER	TCC_AWP_DEC
#else
#define AMRWBPLUS_DECODER	0
#endif

#ifdef INCLUDE_WMA_DEC
#define WMA_DECODER	TCC_WMA_DEC
#else
#define WMA_DECODER	0
#endif	

#ifdef INCLUDE_EVRC_DEC
#define EVRC_DECODER	TCC_EVRC_DEC
#else
#define EVRC_DECODER	0
#endif	

#ifdef INCLUDE_FLAC_DEC
#define FLAC_DECODER	TCC_FLAC_DEC
#else
#define FLAC_DECODER	0
#endif	

#ifdef INCLUDE_RAG2_DEC
#define RAG2_DECODER	TCC_RAG2_DEC
#else
#define RAG2_DECODER	0
#endif	

#ifdef INCLUDE_G722_DEC
#define G722_DECODER	TCC_G722_DEC
#else
#define G722_DECODER	0
#endif	

#ifdef INCLUDE_G729AB_DEC
#define G729AB_DECODER	TCC_G729AB_DEC
#else
#define G729AB_DECODER	0
#endif	

#ifdef INCLUDE_APE_DEC
#define APE_DECODER	TCC_APE_DEC
#else
#define APE_DECODER	0
#endif	

#ifdef INCLUDE_WAV_DEC
#define WAV_DECODER	TCC_WAV_DEC
#else
#define WAV_DECODER	0
#endif

#ifdef INCLUDE_DRA_DEC
#define DRA_DECODER	TCC_DRA_DEC
#else
#define DRA_DECODER	0
#endif

#ifdef INCLUDE_VORBIS_DEC
#define VORBIS_DECODER	TCC_VORBIS_DEC
#else
#define VORBIS_DECODER	0
#endif	

#ifdef INCLUDE_BSAC_DEC
#define BSAC_DECODER	TCC_BSAC_DEC
#else
#define BSAC_DECODER	0
#endif

#ifdef INCLUDE_DDP_DEC
#define DDP_DECODER	TCC_DDP_DEC
#else
#define DDP_DECODER	0
#endif
/************************************************************************

				Audio Encoder List
				
*************************************************************************/


int TCC_CDK_GetADecSampleRate(void);
int TCC_CDK_GetADecChannel(void);
int TCC_CDK_GetADecSamplePerChannel(void);
int TCC_CDK_GetADecBitsPerSample(void);
void TCC_CDK_SetADecSamplePerChannel(int samplenum);
int TCC_CDK_GetAudioMinDataSize(void);
int TCC_CDK_GetADecDataOrder(void);


#ifdef __cplusplus
}
#endif
#endif //_CDK_AUDIO_H_
