#ifndef _CDK_USER_DEBUG_LEVEL_H_
#define _CDK_USER_DEBUG_LEVEL_H_

#define CDK_DEB_LEV_NO_OUTPUT  0
#define CDK_DEB_LEV_ERR        1 
#define CDK_DEB_LEV_PARAMS     2
#define CDK_DEB_LEV_SIMPLE_SEQ 4
#define CDK_DEB_LEV_FULL_SEQ   8
#define CDK_DEB_LEV_FUNCTION_NAME 16
#define CDK_DEFAULT_MESSAGES 32

#define CDK_DEB_ALL_MESS   255

#define CDK_DEBUG_LEVEL (CDK_DEB_LEV_NO_OUTPUT | CDK_DEB_LEV_ERR )
#if CDK_DEBUG_LEVEL > 0
#define CDK_DEBUG(n, args...) do { if (CDK_DEBUG_LEVEL & (n)){fprintf(stderr, "$$$-%d ",__LINE__); fprintf(stderr, args);} } while (0)
#else
#define CDK_DEBUG(n, args...)
#endif

#endif /* _CDK_USER_DEBUG_LEVEL_H_ */