#include "rm_common.h"

#define RM_FILECACHE_SIZE	(1 * 1024)

#define RV_DEPACK_ONE_FRAME	100
#define RA_DEPACK_ONE_FRAME 200

#define AV_AUDIO_RAAAC			0x72616163
#define AV_AUDIO_RACP			0x72616370
#define AV_AUDIO_COOK			0x636F6F6B

#define HX_RV30VIDEO_ID   0x52563330  /* 'RV30' */
#define HX_RV40VIDEO_ID   0x52563430  /* 'RV40' */
#define HX_RV89COMBO_ID   0x54524F4D  /* 'TROM' (raw TCK format) */

#define RMFF_MODE_SEQUENTIAL		0x0
#define RMFF_MODE_INTERLEAVED		0x1
#define RMFF_SUPPORT_STREAMMING		0x2

typedef rm_common_callback_func_t rmff_dmx_callback_func_t;

typedef int rmff_dmx_handle_t; //!< handle of librmff
typedef int rmff_dmx_result_t; //!< return value of librmff

typedef rm_common_dmx_info_t rm_dmx_info_t;
//! init parameter of TCC_RMFF_DMX()
typedef struct rmff_dmx_init_t 
{
	void* m_pOpenFileName;						//!< [in] open file name( when Op is INIT )
	rmff_dmx_callback_func_t m_sCallbackFunc;	//!< [in] callback functions of librmff
	rmff_dmx_handle_t m_ContainerHandle;
	int m_FileCachSize;
	int m_GetStreamMode;
	int m_StreammingSupport;
	int m_load_index_mem;
} rmff_dmx_init_t;

// output information of TCC_RMFF_DMX
//typedef common_dmx_info_t rmff_dmx_info_t; 

//! input parameter of TCC_RMFF_DMX()
typedef struct rmff_dmx_input_t
{
	int m_iPacketType;					//!< [in] PACKET_NONE or PACKET_VIDEO or PACKET_AUDIO
	unsigned char* m_pPacketBuff;		//!< [in] allocated packet(video or audio) buffer pointer
	int m_iPacketBuffSize;				//!< [in] allocated packet(video or audio) buffer size
										//!< if m_pPacketBuffer is zero, rmff parser's internal memory will be used.
} rmff_dmx_input_t;

typedef struct segment_struct
{
    int m_ibIsValid;
    unsigned long int m_ulOffset;
} segment;

//! output parameter of TCC_RMFF_DMX()
typedef struct rmff_dmx_output_t
{
	unsigned char* m_pData;	//!< pointer of output data
	int m_iDataSize;		//!< length of output data
	int m_iPacketType;		//!< packet type of output data
	int m_bKeyFrame;		//!< key flag of output data
	int m_iRefTime;			//!< time(msec) of output data
	int m_iKeyCount;		//!< current key count
	////////rv_frame////////
	char*	m_frame_info;
	int             m_iDataLen;
	char*              m_rv_pData;
	int             m_iTimestamp;
	short             m_sSequenceNum;
	short             m_sFlags;
	int             m_ibLastPacket;
	int             m_iNumSegments;
	segment*        m_pSegment;

	/////////ra_block/////////
	char* m_Audio_info;
	unsigned char*  m_Audio_pData;
	int m_iAudio_ulDataLen;
	int m_iAudio_ulTimestamp;
	int m_iAudio_ulDataFlags;
	int m_iAudio_ulNumAU;
	int m_iAudio_dBlockDuration;
	/////////ra_block/////////
	
	int m_Reserved[32-21];	//!< reserved...
} rmff_dmx_output_t;


//! seek parameter of TCC_RMFF_DMX()
typedef struct rmff_dmx_seek_t
{
	int m_iSeekTimeMSec;		//!< seek time(second) from current time
	int m_iSeekMode;			//!< 0(default video) 1(video) 2(audio)
	int m_iVideoTime_AfterSeek;
	int m_iAudioTime_AfterSeek;
} rmff_dmx_seek_t;


int TCC_RMFF_DMX(int Op, unsigned int *fp_handle, void* pParam1, void* pParam2 );



