
/*!
 ***********************************************************************
 \par Copyright
 \verbatim
  ________  _____           _____   _____           ____  ____   ____		
     /     /       /       /       /       /     /   /    /   \ /			
    /     /___    /       /___    /       /____ /   /    /____/ \___			
   /     /       /       /       /       /     /   /    /           \		
  /     /_____  /_____  /_____  /_____  /     / _ /_  _/_      _____/ 		
   																				
  Copyright (c) 2009 Telechips Inc.
  Korad Bldg, 1000-12 Daechi-dong, Kangnam-Ku, Seoul, Korea					
 \endverbatim
 ***********************************************************************
 */
/*!
 ***********************************************************************
 *
 * \file
 *		tcc_mp123_dmx.h
 * \date
 *		2010/07/12
 * \author
 *		AValgorithm@telechips.com
 * \brief
 *		mpeg audio demuxer ( mp3, mp2 )
 * \version
 *		1.0.0 : 2010/07/12
 *		
 ***********************************************************************
 */

#ifndef _TCC_MP123_AUDIO_DMX_H_
#define _TCC_MP123_AUDIO_DMX_H_

#ifndef NULL
#define NULL 0
#endif

#ifndef SEEK_SET
#define SEEK_SET    0
#endif

#ifndef SEEK_CUR
#define SEEK_CUR    1
#endif

#ifndef SEEK_END
#define SEEK_END    2
#endif

#ifndef ABS
#define ABS(a) (((a)>0)?(a):-(a))
#endif

#ifndef MAX
#define MAX(a,b) ((a)>(b)?(a):(b))
#endif

typedef int H_MPEG_AUDIO_DMX;

typedef struct mpeg_audio_frame_info_t
{
	unsigned int    m_uiHeaderRaw;
	unsigned int	m_uiBitRate;
	unsigned int	m_uiChannels;
	unsigned int 	m_uiSampleRate;
	unsigned int 	m_uiLayer;
	unsigned int	m_uiVersion;
	unsigned int 	m_uiFrameSize;
} mpeg_audio_frame_info_t;

typedef struct mpeg_audio_file_info_t
{
	unsigned char	*m_pucBuffer;
	unsigned char	*m_pucStartPtr;
	int				m_iStartSize;
	int				m_iCheckCnt;
	unsigned int	m_uiCheckDone;
	unsigned int	m_uiFirstFramePosition;

	unsigned int	m_uiSampleRate;
	unsigned int	m_uiChannels;
	unsigned int	m_uiAvgBitRate;
	unsigned int	m_uiBitRate;
	unsigned int	m_uiVBRFlag;
	
	unsigned int	m_uiLayer;
	unsigned int	m_uiTotalTime;
	unsigned int	m_uiRefHeaderRaw;
	unsigned int	m_uiIsMpegAudio;

	ui64_t			m_ullPayloadSize;
	ui64_t			m_ullFileLength;
	
	unsigned int	m_uiAverageBitrate;
	unsigned int	m_uiPrevBitrate;
	unsigned int	m_uiBitrateCount;
	unsigned int	m_uiFirstBitRate;

	unsigned int	m_uiHasVbrHeader;
	unsigned int	m_uiVbrHeaderBitRate;
	unsigned int	m_uiVbrFlag;

} mpeg_audio_file_info_t;

typedef struct mp123_dmx_info_t
{
	void			*m_pInfile;
	unsigned char	*m_pucStreamBuffer;
	unsigned char	*m_pucCurrPtr;	
	unsigned char	*m_pucFrameBuffer;
	
	int				m_iBytesLeft;

	unsigned int	m_uiRefHeaderRaw;
	unsigned int	m_uiCurrHeaderRaw;
	unsigned int 	m_uiFrameSize;
	unsigned int	m_uiTotalPlayTime;
	unsigned int	m_uiLayer;
	unsigned int	m_uiSamplerate;
	unsigned int	m_uiChannels;
	unsigned int	m_uiBitrate;
	unsigned int	m_uiFirstFramePosition;
	unsigned int    m_uiSamplesPerChannel;
	unsigned int	m_uiTime;

	ui64_t			m_ullTimePos;
	ui64_t			m_ullFileSize;
	ui64_t			m_ullPayloadSize;
	
	//unsigned int	m_uiTotalFrame;
	//unsigned int	m_uiId3TagSiz;
	
}mp123_dmx_info_t;

#define READBUF_SIZE		(64 * 1024)
#define FRAMEBUF_SIZE		(1437 * 2)

#if (READBUF_SIZE <= FRAMEBUF_SIZE)
#error READBUF_SIZE must be larger than FRAMEBUF_SIZE
#endif

#endif	/* _TCC_MP123_AUDIO_DMX_H_ */
