/*!
 ***********************************************************************
 \par Copyright
 \verbatim
  ________  _____           _____   _____           ____  ____   ____
     /     /       /       /       /       /     /   /    /   \ /
    /     /___    /       /___    /       /____ /   /    /____/ \___
   /     /       /       /       /       /     /   /    /           \
  /     /_____  /_____  /_____  /_____  /     / _ /_  _/_      _____/

  Copyright (c) 2009 Telechips Inc.
  Korad Bldg, 1000-12 Daechi-dong, Kangnam-Ku, Seoul, Korea
 \endverbatim
 ***********************************************************************
 */
/*!
 ***********************************************************************
 *
 * \file
 *		vpu_clk_ctrl.h
 * \date
 *		2009/10/09
 * \author
 *		AV algorithm group(AValgorithm@telechips.com)
 * \brief
 *		vpu clock and mem. region control
 * \version
 *		0.0.1 : 2009/10/09	(2009/10/01 LINUX BSP)
 *
 ***********************************************************************
 */
#ifndef _VPU_CLK_CTRL_H_
#define _VPU_CLK_CTRL_H_

#include "cdk_pre_define.h"
#ifdef VPU_CLK_CONTROL

/************************************************************************/
/*						                                                */
/* Defines				                                                */
/*						                                                */
/************************************************************************/

#define VPU_CLK_CTRL_VBUCONF_SOFTRESET_OFFSET	0x00000004
#if defined( TCC_892X_INCLUDE )
	#define VPU_CLK_RESET_TYPE					5
	#define VPU_CLK_CTRL_VBUCONF_SOFTRESET_MASK		(1<<2)	//VAL[0] bit :  : 0 for reset / 1 for Not-reset
	#define VPU_CLK_CTRL_CKC_SWRESET_REG_OFFSET	0x00000064	//SWRESET : 0x Bus Software Reset Control Register
	#define VPU_CLK_CTRL_CKC_SWRESET_VCORE_MASK		(1<<6)	//SWRST[6] bit : 0 for reset / 1 for Not-reset
	#define VPU_CLK_CTRL_CKC_SWRESET_VBUS_MASK		(1<<5)	//SWRST[5] bit : 0 for reset / 1 for Not-reset
	//#define VPU_CLK_CTRL_CKC_CLKCTRL5_OFFSET	0x00000014	//CLKCTRL5: 0x74000014 Bus clock control register for video codec
	//#define VPU_CLK_CTRL_CKC_CLKCTRL6_OFFSET	0x00000018	//CLKCTRL6: 0x74000018 Core clock control register for video codec
	//#define CKC_REG_BASE_ADDR					0x74000000	//CKC Register ( include CLKCTRL5 / CLKCTRL6 / SWRESET )
	//#define VPU_REG_BASE_ADDR					0x75000000	//Video CODEC
	//#define VIDEOCACHE_BASE_ADDR							//Video cache controller
	//#define VIDEOBUSCONF_BASE_ADDR			0x75200000	//Video Bus Configuration
	//#define JPEG_CLK_CTRL_VBUCONF_SOFTRESET_MASK	(1<<0)	//VAL[0] bit :  : 0 for reset / 1 for Not-reset
	//#define JPEG_CLK_CTRL_PCLKCTRL09			0x740000A4	//PCLKCTRL09 : JPEG clock
	//#define JPEG_REG_BASE_ADDR				0x75300000	//JPEG CODEC
#endif


#define VPU_CLK_CTRL_VBUS_PWR_DOWN_CODEC_MASK	(1<<2)
#define VPU_CLK_CTRL_CKLCTRL_SEL				( 0)
#define VPU_CLK_CTRL_CKLCTRL_SYNC				( 3)
#define VPU_CLK_CTRL_CKLCTRL_CONFIG				( 4)
#define VPU_CLK_CTRL_CKLCTRL_MD					(20)
#define VPU_CLK_CTRL_CKLCTRL_EN					(21)

/*!
 ***********************************************************************
 * \brief
 *		vpu clock init. function for LINUX
 ***********************************************************************
 */
int
vpu_clock_init(void);

/*!
 ***********************************************************************
 * \brief
 *		vpu clock deinit. function for LINUX
 ***********************************************************************
 */
int
vpu_clock_deinit(void);

/*!
 ***********************************************************************
 * \brief
 *		vpu clock reset function for LINUX
 ***********************************************************************
 */
void
vpu_clock_reset( unsigned int ckc_reg_base, unsigned int vbusConf_reg_base);

#endif //VPU_CLK_CONTROL

#endif //_VPU_CLK_CTRL_H_
