/****************************************************************************
 *   FileName    : mRecord.h
 *   Description : 
 ****************************************************************************
 *
 *   TCC Version 1.0
 *   Copyright (c) Telechips, Inc.
 *   ALL RIGHTS RESERVED
 *
 ****************************************************************************/

/****************************************************************************

  Revision History

 ****************************************************************************
 
 ****************************************************************************/

#ifndef _MRECORD_H_
#define _MRECORD_H_

#define MAX_RECORD_TIME 		5*60*60 - 1
#define MIN_SIZE_FOR_RECORD		1*1024 //Kbytes
#define REC_FILE_NAME_SIZE		11

#define Mic_In			4
#define Line_In 		6
#define Mixer_switch	11


enum
{
	LINEIN_REC,
	VOICE_REC,
	FM_REC
};

enum
{
	FORMAT_MP3,
	FORMAT_WAV,
	FORMAT_WMA,
	FORMAT_AAC,
	FORMAT_MAX
};

enum
{
	REC_MP3_NULL,
	REC_MP3_SETTING_16,
	REC_MP3_SETTING_24,
	REC_MP3_SETTING_32,
	REC_MP3_SETTING_40,
	REC_MP3_SETTING_48,
	REC_MP3_SETTING_56,
	REC_MP3_SETTING_64,
	REC_MP3_SETTING_80,
	REC_MP3_SETTING_96,
	REC_MP3_SETTING_112,
	REC_MP3_SETTING_128,
	REC_MP3_SETTING_160,
	REC_MP3_SETTING_192,
};

enum
{
	REC_WMA_NULL,
	REC_WMA_SETTING_32,
	REC_WMA_SETTING_48,
	REC_WMA_SETTING_64,
	REC_WMA_SETTING_80,
	REC_WMA_SETTING_96,
	REC_WMA_SETTING_128,
};

enum
{
	REC_WAV_NULL,
	REC_WAV_SETTING_8000,
	REC_WAV_SETTING_11025,
	REC_WAV_SETTING_22050,
	REC_WAV_SETTING_32000,
	REC_WAV_SETTING_44100,
};

enum
{
	REC_AAC_NULL,
	REC_AAC_SETTING_16,
	REC_AAC_SETTING_24,
	REC_AAC_SETTING_32,
	REC_AAC_SETTING_40,
	REC_AAC_SETTING_48,
	REC_AAC_SETTING_56,
	REC_AAC_SETTING_64,
	REC_AAC_SETTING_72,
	REC_AAC_SETTING_80,
	REC_AAC_SETTING_96,
	REC_AAC_SETTING_128,
	REC_AAC_SETTING_160,
	REC_AAC_SETTING_192,
	REC_AAC_SETTING_224,
	REC_AAC_SETTING_256,
	REC_AAC_SETTING_288
};

typedef enum AACHeaderype
{
	FORMAT_RAW = 0,
	FORMAT_ADIF = 1,
	FORMAT_ADTS = 2
}AACHeaderype;

#endif
