/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : fig.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/


#ifndef		__FIG_H__
#define		__FIG_H__

#define VERSION_FIC_PARSER "1.0.9"

#ifdef __cplusplus
extern "C" {
#endif

#if defined(_WIN32)
	#define CALLSPEC	__cdecl
#else
	#define CALLSPEC
#endif

#ifdef __TARGET_CPU_ARM940T
#ifndef TCC76X
	#define TCC76X
#endif
#endif

typedef	unsigned char	uchar;
typedef unsigned long ulong;
typedef unsigned short ushort;
typedef unsigned int uint;

#define		FIG0			0x0
#define		FIG1			0x1
#define		FIG5			0x5
#define		FIG6			0x6
#define		FIG7			0x7

#define		Ext00		0
#define		Ext01		1
#define		Ext02		2
#define		Ext03		3
#define		Ext04		4
#define		Ext05		5
#define		Ext06		6
#define		Ext07		7
#define		Ext08		8
#define		Ext09		9
#define		Ext10		10
#define		Ext11		11
#define		Ext12		12
#define		Ext13		13
#define		Ext14		14
#define		Ext15		15
#define		Ext16		16
#define		Ext17		17
#define		Ext18		18
#define		Ext19		19
#define		Ext20		20
#define		Ext21		21
#define		Ext22		22
#define		Ext23		23
#define		Ext24		24
#define		Ext25		25
#define		Ext26		26
#define		Ext27		27
#define		Ext28		28
#define		Ext29		29
#define		Ext30		30
#define		Ext31		31
#define		Ext01_R		40

#define		_NumOfSvc			20
#define		_NumOfSubCh		(_NumOfSvc + 0)
#define		_NumOfSvcComp		_NumOfSubCh

#define		_NumOfProgramNum	5
#define		_NumOfProgType		_NumOfSvcComp
#define		_TotalEnsemble		10
#define		_NumOfMainId		3
#define		_NumOfAnn			5		// num of announcement
#define		_NumOfUserApp		_NumOfSvc
#define		_TotalService		100
#define		_MaxSvcPerEsb		20
#define 	_TotalFavorite		20 
#define		_NumOfFI			4
#define		_NumServiceLink	4
#define		_NumOfOESvc		_NumOfSvc



#define		ONLY_AUDIO_SERVICE	0

#define CRC16_POLYNOMIAL 	0x1021		//x^16 + x^12 + x^5 + 1;

#define USR_APP_TY_RESERVE		0
#define USR_APP_TY_DLS			1
#define USR_APP_TY_SLIDESHOW	2
#define USR_APP_TY_BWS			3
#define USR_APP_TY_TPEG		4
#define USR_APP_TY_DGPS		5
#define USR_APP_TY_TMC			6
#define USR_APP_TY_EPG			7
#define USR_APP_TY_PAD			8
#define USR_APP_TY_BIFS			9
#define USR_APP_TY_CAAGENT		10

#define USR_APP_TY_MAXNUM		10		//USR_APP_TY_RESERVE ~ USR_APP_TY_BIFS
#define TABLE_LOCK_INCLUDE

typedef enum{
	SVCCOMP_LABEL_NONE=1,
	SVCCOMP_LABEL_SEC_NOT,
	SVCCOMP_LABEL_SEC_TOBE
}SVCCOMP_LABEL_INFO;

typedef struct{	
	//FIG 0/1
	uchar	SubChId;		// 6bits	Sub channel Id
	uchar	TblIndex;		// 6bits	TableIndex
	uchar	Form_Opt_Prot;
					//[3] : FormFlag
					//[2] : Option
					//[1~0] : protection
	ushort	StrtAdd;		// 10bits	Start Address
	ushort	SubChSize;		// 10bits	Sub channel size
}SubChInfo;

typedef struct {
	/* FIG 0/2 */
	uchar		Order;			// 4bits
	uchar		TMId;			// 2bits	Transport Mechanism Id
	uchar		ASCTy_DSCTy;	// 6bits	Audio Service Component Type	
	uchar		SubCh_FIDCId;	// 6bits	SubChId or FIDCId in FIG 0/4
	uchar		CAflag;			// 1bit		CA Flag
	uchar		DG_MFflag;		// 1bit		DG Flag or MF flag	
	uchar		Language;		// 8bit
	uchar		SCIdS;			// 4bit		Service component Identifier within ther Service
	uchar		CAOrgFlag;		// 1bit
	uchar		charset;
	uchar		Label[16];		// 16bytes	Service component Label
	ushort		SCId;			// 12bits	Service Component Id
	ushort		PackAdd;		// 10bits	Packet Address
	ushort		CAOrg;			// 16bits	conditional access organization
	ushort		CharacterFlag;
	ulong		SId;				// 16bit
}SvcComponentInfo;


typedef struct{
	// FIG 0/10
	uchar	LSI;			//1bit
	uchar	ConfInd;		//1bit
	uchar	UTCflag;		//1bit
	ulong	UTC;			//11 or 27bit
	ulong	MJD;			//17bit	Modified Julian Date
}DateTimeInfo;

typedef struct{
	//FIG 0/12
	uchar	Lflag;			//1bit
	uchar	FF;				//2bit
	uchar	Language;		//8bit
//	uchar	FlagField[192];	//32 ~ 192bit
	uchar	FlagField[32];	//32 ~ 192bit
	ushort	EId;			//16bit
}ProgTypePrevInfo;

typedef struct {
	// FIG 0/16;
	uchar	ContFlag;		//1bit
	uchar	UpdateFlag;		//1bit
	ushort	SId;			//16bit
	ushort	PNum;			//16bit
	ushort	NewSId;			//16bit
	ushort	NewPNum;		//16bit
}ProgNumberInfo;

typedef struct{
	//FIG 0/17
	uchar	SD;				//1bit
	uchar	PS;				//1bit
	uchar	NFC;			//2bit
	uchar	IntCode;		//5bit
	uchar	CoarseCode;		//6bit
	uchar	FineCode;		//8bit
	ushort	SId;			//16bit
}ProgramTypeInfo;

typedef struct {
	//FIG 1/2
	uchar country_flag;
	uchar coarse_code;
	uchar fine_code;
	uchar language;
	uchar charset;
	uchar character_field[16];
	ushort chr_flag_field;
	uchar ECC;
	uchar country_id;	
}ProgramTypedownInfo;


typedef struct{
	/*	FIG 0/2	*/
	ulong		SId;			// 32bits	CountryId + serviceReference // ECC + CountryId + ServiceReference
#ifdef	TCC76X
	uchar		charset;
	uchar		Label[16];
#else	
	uchar		charset;
	uchar		SvcLabel[16];	// 16bytes	Service Label(Program service and Data service)
#endif	
	ushort		CharacterFlag;
	uchar		CAId;			// 3bit
	uchar		NumSvcComp;		// 4bits	Number of Service Component
} ServiceInfo;

typedef struct{
	/*	FIG 0/0	*/
	uchar	AlFlag;				// 1bit		Al flag
	uchar   NumSubCh;
	uchar   NumSvc;
	uchar	NumProgram;
	uchar   NumSvcComp;
	uchar	NumUserApp;
	uchar	NumAnn;
	uchar	NumProgType;
	uchar	NumSvcLink;
	uchar	NumOESvc;
	uchar	NumFI;
#ifdef	TCC76X
	uchar	charset;
	uchar	Label[16];
#else
	uchar	charset;
	uchar	EnsemLabel[16];		// 16bytes	Ensemble Label
#endif	
	ushort CharacterFlag;
	ushort	EId;				// 16bits	country Id Ensemble reference
} EnsembleInfo;

typedef struct{
	ushort AsuFlag;				// Announcement support flag
	ushort AswFlag;				// Announcement switching flag
	ushort	SId;
	uchar NumCluster;			// number of cluster
	uchar SubChId;				// sub-channel Id
	uchar ClusterId[10];		// cluster Id
}AnnouncementInfo;

typedef struct{
	uchar	SubId;				// 5bits SubId
	ushort	TD;					// 11bits Time Delay
	ushort	LatitudeOffset;		// 16bits Latitude offset
	ushort	LongitudeOffset;	// 16bits Longitude offset
}TIISubIdInfo;

typedef struct{
	short	CoaLatitude;			// 16bits	Coarse Latitude
	short	CoaLongitude;			// 16bits	Coarse Longitude
	uchar	MainId;				// 7bits	TII Main Id
	uchar	FineLatitude;			// 4bits	Fine Latitude
	uchar	FineLongitude;			// 4bits	Fine Longitude
	uchar	NumSubId;				// 3bits 	Number of SubId fields
	TIISubIdInfo	TIISubId[20];
} TIIDatabaseInfo;

typedef struct
{
	int   PADLen;		// Total XPAD data length
	uchar Toggle;		// the state of DLS
	uchar Charset;
	uchar State;
	uchar *SubFieldPAD;
} XPAD_DLS_Info;

typedef struct {
	uchar Message[15];
	uchar NumMsg;
	uchar flag;			// 0=TMC user Message 
						// 1=TMC system message 
						// 2=EWS message
						// 3=EWS control info
}TMC_EWSInfo;

/* FIG0/13*/
typedef struct {
	ulong	SId;
	uchar	SCIdS;
	uchar	NumApp;
	ushort	AppTy;
	uchar	AppLen;
	uchar	AppData[3][24];
}UserAppInfo;

typedef struct {
	int		PacketAddr;
	int		TId;
	int		SegNum;
	uchar	bCRC;
	uchar	bSegment;
	uchar	bAccess;
	uchar	DGTy;
	uchar	Cont_Idx;
	uchar	Rep_Idx;
	uchar	*DataField;
}PacketInfo;
/* FIG0/6*/
typedef struct {
	uchar	LA;
	uchar	SH;
	uchar	ILS;
	uchar	IdLQ;
	uchar	Shd;
	uchar	NumOfIds;
	uchar	Mode;
	uchar	IdList[24];
	ushort	LSN;
}ServiceLinkInfo;
/* FIG0/21*/
typedef struct {
	ushort	Id;
	uchar	RM;
	uchar	ContF;
	uchar	NumFreqList;
	uchar	Mode;
	uchar	freqlist[26];
}FIListInfo;
/* FIG0/21*/
typedef struct {
	ushort		RId;
	uchar		OE;
	uchar		NumFIList;
	FIListInfo		filist[20];
}DABFrequencyInfo;
/* FIG0/24*/
typedef struct {
	ulong		SId;
	uchar		CAId;
	uchar		NumEId;
	ushort		EId[12];
}OEServiceInfo;

/* FIG6 (CAS)*/
typedef struct {
	uchar		CN;
	uchar		PD;
	uchar		OE;
	uchar		LEF;
	uchar		S_CASysId;
	uchar		CAIntCharLen;
	uchar		CAIntChar[24];
	ulong		SId;
	ushort		CASysId;
}FIG6Info;

typedef struct{
	ushort	EId;			// 16bits	country Id Ensemble reference
	ushort	CharFlag;
	uchar   NumSvc;
	uchar   NumSvcComp;
	uchar   NumSubCh;
	uchar	Band;
	uchar	FreqIdx;
#ifdef  TCC77X
	SVCCOMP_LABEL_INFO svccomp_label_info;
#endif
#ifdef TCC76X
	uchar	pll_offset;
	uchar	svcidx[_MaxSvcPerEsb];
	uchar	Label[16];	// 16bytes	Ensemble Label
#else
	uchar	Pll_offset;
	uchar	EnsemLabel[16];	// 16bytes	Ensemble Label
	ServiceInfo			Service[_NumOfSvc];
	SubChInfo			SubCh[_NumOfSubCh];
	SvcComponentInfo	SvcComp[_NumOfSvcComp];
#endif
}EnsembleListInfo;

#ifdef TCC76X
typedef struct {
	ulong		SId;
	ushort		DataRate;
	ushort		CharFlag;
	uchar		ASCTy_DSCTy;
	uchar		TMId;
	uchar		SubChId;
	uchar		Order;
	uchar		LabelInfo;
	uchar		Label[16];
	uchar		SubChInfo[7];
}ServiceListInfo;

// added by firewalls on V218[05/11/24]
// modified by ksj [06/04/07]
typedef struct{
	ulong		SId;
	ushort 		EId;
	uchar		SubChId;
	uchar		SvcLabel[16];
}FavoriteListInfo;
#endif

typedef void (*tFICEXTPARSER)(uchar *In, int iLen);

extern uchar	NumTiiMainId;
extern uchar	NumTotalTii;
extern uchar   FIG_CN, FIG_OE0, FIG_PD, FIG_OE1, FIG_D1, FIG_D2, TCId;

extern uchar	LTO_unique;
extern char 	Ensemble_LTO;
extern uchar 	Ensemble_ECC;
extern uchar	Inter_Tb_Id;
extern uchar   gucAppearAnnouncement;

extern uchar	gucFig_ReConfStage;
extern uchar	gucFig_RECONF;
extern uchar	gucFig_Keep_Subch;
extern ushort	giCIFCnt;

extern EnsembleInfo		*psEsb;							//FIG 0/0
extern SubChInfo			*psSubCh;			//FIG 0/1
extern ServiceInfo			*psService;			//FIG 0/2
extern DateTimeInfo		*psDateTime;						//FIG 0/10
//extern ProgTypePrevInfo		*psProgTypePrev;		//FIG 0/12
extern ProgramTypeInfo	*psProgType;
extern ProgramTypedownInfo	*psProgType_download;	//FIG 1/2
extern ProgNumberInfo		*psProgNumber;	//FIG 0/16
extern SvcComponentInfo	*psSvcComponent;
extern TMC_EWSInfo		*psTMC_EWS;
extern UserAppInfo		*psUserApp;				//FIG 0/13

extern XPAD_DLS_Info		*psXPAD;
extern TIIDatabaseInfo		*psTIIDatabase;
extern AnnouncementInfo	*psAnnouncement;		//FIG 0/18 19
extern FIG6Info   *psFIG6;
extern unsigned char 		*pFIG5_Paging;

extern tFICEXTPARSER ExtenalParsingFig5;

/*
//---------------FIG0.c--------------------------------------------------------------------------
extern void FIG0Ext00(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext01(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext02(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext03(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext04(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext05(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext06(uchar *In, EnsembleInfo *p_esb, int cLen);
extern void FIG0Ext07(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext08(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext09(uchar *In, int iLen);
extern void FIG0Ext10(uchar *In, DateTimeInfo *datetime);
extern void FIG0Ext12(uchar *In, ProgTypePrevInfo *progtypeprev);
extern void FIG0Ext13(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext16(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext17(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext18(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext19(uchar *In, EnsembleInfo *Esb, int iLen);
extern void FIG0Ext21(uchar *In, EnsembleInfo *p_esb, int cLen);
extern void FIG0Ext22(uchar *In, uchar ucNum, short sLen);
extern void FIG0Ext24(uchar *In, EnsembleInfo *p_esb, int cLen);
extern void FIG0Ext01_ReConf(uchar *In, int iLen, uchar idx);


//---------------FIG1.c--------------------------------------------------------------------------
extern void 	FIG1Ext00(uchar *In, EnsembleInfo *Esb, int iLen, uchar charset);
extern void 	FIG1Ext01(uchar *In, EnsembleInfo *Esb, int iLen, uchar charset);
extern void 	FIG1Ext04(uchar *In, EnsembleInfo *Esb, uchar charset);
extern void 	FIG1Ext05(uchar *In, EnsembleInfo *Esb, int iLen, uchar charset);

//---------------FIG5.c--------------------------------------------------------------------------
extern void	FIG5Ext00(uchar *In, uchar *out, int iLen);
extern void	FIG5Ext01(uchar *In, TMC_EWSInfo *p_tmc_ews,int iLen);
extern void 	FIG5Ext02(uchar *In, TMC_EWSInfo *p_tmc_ews,int iLen);

//---------------FIG6-------------------------------//
extern void     ParsingFIG6(uchar *In, int iLen);
*/
//extern uchar CALLSPEC CRC16(uchar *data, ushort init, ushort len, uchar flag);
extern uchar CALLSPEC FIC_CRC16(uchar *data, ushort init, ushort len, uchar flag);

extern void CALLSPEC 	Service_Mem_Align(ServiceInfo *p, uchar max);
extern void CALLSPEC 	SvcComponent_Mem_Align(SvcComponentInfo *p, uchar max);
extern void CALLSPEC 	SubCh_Mem_Align(SubChInfo *p, uchar max);
extern void CALLSPEC 	UserApp_Mem_Align(UserAppInfo *p, uchar max);
extern void CALLSPEC 	ProgNumber_Mem_Align(ProgNumberInfo *p, uchar max);
extern void CALLSPEC 	TII_Mem_Align(TIIDatabaseInfo *p, uchar max);
extern void CALLSPEC 	Announcement_Mem_Align(AnnouncementInfo *p, uchar max);  
extern void CALLSPEC 	ProgramType_Mem_Align(ProgramTypeInfo *p, uchar max);
extern void CALLSPEC   Ensemble_Mem_Align(EnsembleInfo *p);
extern void CALLSPEC    ProgramType_Mem_Align(ProgramTypeInfo *p, uchar max);
extern void CALLSPEC   Set_SubChId_To_Parser(uchar subch_id);
extern void CALLSPEC    DateTime_Mem_Align(DateTimeInfo *p);
extern void CALLSPEC    Paging_Mem_Align(uchar *p);
extern void CALLSPEC    TMC_EWS_Mem_Align(TMC_EWSInfo *p);
extern void CALLSPEC    XPAD_Mem_Align(XPAD_DLS_Info *p);
extern void CALLSPEC ServiceLinkInfo_Mem_Align(ServiceLinkInfo*p, uchar max);
extern void CALLSPEC FrequencyListInfo_Mem_Align(DABFrequencyInfo*p, uchar max);
extern void CALLSPEC OEServiceInfo_Mem_Align( OEServiceInfo * p, uchar max);
extern void CALLSPEC FIG6Info_Mem_Align(FIG6Info*p);
extern void CALLSPEC Packet_Mem_Align(PacketInfo *p);

extern void CALLSPEC FIC_InitTableLock(uchar t1stlock,uchar t2ndlock,uchar t3thlock,int mincrc,int maxcrc,int logOnOff);
extern void CALLSPEC FIC_UpdateDecisionCRC(ushort crc);
//api
extern uchar CALLSPEC FIC_GetSCIdS(ulong SId, ushort SCId);
extern void FIBDecoding(uchar *In);

#ifdef TCC76X
	extern void 	ParserInit(uchar);
//	extern void CALLSPEC   EnsembleList_Mem_Align(EnsembleListInfo * p, uchar max);
//	extern void CALLSPEC    ServiceList_Mem_Align(ServiceListInfo * p, uchar max);

#else
	extern void CALLSPEC 	Parsing_Buffer_Init(uchar);
#endif
//extern uchar CALLSPEC 	CRC16(uchar *data, ushort init, ushort, uchar);

#undef CALLSPEC

#ifdef __cplusplus
}
#endif

#endif	/* _FIG_H_ */

/* end of file */

