/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : tcc_audio_common.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/

#ifndef __TCC_AUDIO_COMMON__
#define __TCC_AUDIO_COMMON__

#define AUDIO_FILENAME_LEN 			512

#define AUDIO_PCM_OUTPUT_MAX_LENGTH 	1024*200
#define AUDIO_PCM_OUTPUT_LEFT_LENGTH 	1024*50
#define AUDIO_PCM_OUTPUT_RIGHT_LENGTH 	1024*50
#define AUDIO_PARSER_WORKBUF_LENGTH		1024*100

#define AUDIO_ERROR_DETECT_COUNT 5

#define MAX_COMPONENT_AUDIO_PARSER	1

#define CODEC_SEEK_FF                       0x00000000
#define CODEC_SEEK_REW                      0x00000001
#define CODEC_SEEK_OTHER                    0x00000002


/*Audio Parser Name Definition*/
#define AUDIO_CDK_DMX_NAME		"OMX.tcc.demuxer.cdk_audio"
#define AUDIO_CDK_DEC_NAME 		"OMX.tcc.audio_decoder.cdk"
#define AUDIO_DEQ_NAME 			"OMX.tcc.deq.component"

#define TCC_AUDIO_EXIFPARSE_INCLUDE

#define AUDIO_SEEK_X1_MODE	1
#define AUDIO_SEEK_X2_MODE	2
#define AUDIO_SEEK_X4_MODE  4
#define AUDIO_SEEK_X8_MODE  8
#define AUDIO_SEEK_X16_MODE 16

#define AUDIO_SEEK_DIRECTION_REW	0
#define AUDIO_SEEK_DIRECTION_FF		1

#define AUDIO_DYNAMIC_SETP_OFF	0
#define AUDIO_DYNAMIC_SETP1		1
#define AUDIO_DYNAMIC_SETP2		2
#define AUDIO_DYNAMIC_SETP3		3
#define AUDIO_DYNAMIC_SETP4		4
#define AUDIO_DYNAMIC_SETP5		5
#define AUDIO_DYNAMIC_SETP6		6
#define AUDIO_DYNAMIC_SETP7		7
#define AUDIO_DYNAMIC_SETP8		8

#define AUDIO_CH_LR_MODE		0
#define AUDIO_CH_LL_MODE		1
#define AUDIO_CH_RR_MODE		2

#define EXTRAMODEOFF					0x0000
#define EXTRAMODENERGYELEVEL			0x0001
#define EXTRAMODEPOWERSPECTRUM			0x0002


#define  SCERR_NO									0
#define  SCERR_NO_PROC_DEVICE                      -1    // /proc/device   ʴ´.
#define  SCERR_DRIVER_NO_FIND                      -2    // /proc/device  ̹ ã 
#define  SCERR_NO_SOUNDCARD                        -3    //  ī尡 
#define  SCERR_NO_MIXER                            -4    // ͼ 
#define  SCERR_OPEN_SOUNDCARD                      -5    //  ī带 µ  ߴ.
#define  SCERR_OPEN_MIXER                          -6    //  ī带 µ  ߴ.
#define  SCERR_PRIVILEGE_SOUNDCARD                 -7    //  ī带   
#define  SCERR_PRIVILEGE_MIXER                     -8    // ̼   

#define  SCERR_NO_FILE                             -10   //  
#define  SCERR_NOT_OPEN                            -11   //    
#define  SCERR_NOT_WAV_FILE                        -12   // WAV  ƴ
#define  SCERR_NO_wav_info                       -13   // WAV   

#define	MONO					1		// Macro for GetEnergyofVolume Function
#define	STEREO					2		// Macro for GetEnergyofVolume Function
#define	SAMPLE_COUNT			10		// count of samples for GetEnergyofVolume Function

#define MAX_FILENAME_SIZE		256
#define TRUE                 1
#define FALSE                0

typedef enum Audio_Enc_Codec_Type
{
	AUDIO_ENC_CODEC_NULL =0,
	AUDIO_ENC_CODEC_MP3 ,
	AUDIO_ENC_CODEC_PCM,
	AUDIO_ENC_CODEC_ADPCM,
	AUDIO_ENC_CODEC_WMA,
	AUDIO_ENC_CODEC_AAC,
	AUDIO_ENC_CODEC_NUM
}Audio_Enc_Codec_Type ;


#define MP3_DATA_SIZE 1500
#define MP2_DATA_SIZE 2048
#define APE_DATA_SIZE (7*1024)*2

extern void GetEnergyofVolume ( short *left, short *right, int buff_length,int LR,unsigned int* left_level, unsigned int* right_level);

#endif /* __TCC_AUDIO_COMMON__ */
