/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : tcc_audio_ioctl.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/

#ifndef __TCC_AUDIO_IOCTL_H__
#define __TCC_AUDIO_IOCTL_H__

#define MAJOR_NUM 247
#define DEV_NAME "/dev/tcc-ioctl-ckc"

/* ioctl for audio */
#define IOCTL_ADMA_START            _IO(MAJOR_NUM, 150)
#define IOCTL_ADMA_STOP             _IO(MAJOR_NUM, 151)

#define IOCTL_I2S_START             _IO(MAJOR_NUM, 152)
#define IOCTL_I2S_STOP              _IO(MAJOR_NUM, 153)

#define IOCTL_GET_DAI_CKC           _IO(MAJOR_NUM, 154)
#define IOCTL_INC_DAI_CKC           _IO(MAJOR_NUM, 155)
#define IOCTL_DEC_DAI_CKC           _IO(MAJOR_NUM, 156)


#define AUDIO_PLAYBACK_CTRL_ID      0x0001
#define AUDIO_CAPTURE_CTRL_ID       0x0002
#define AUDIO_SPDIF_CTRL_ID         0x0003

struct tcc_audio_ioctl {
    int audio_num;
    unsigned int sample_rate;
};


#endif /* __TCC_AUDIO_IOCTL_H__ */
