/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : TCCFile.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/
#ifndef	_TCC_FILE_H__
#define	_TCC_FILE_H__

/******************************************************************************
* include 
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
/******************************************************************************
* typedefs & structure
******************************************************************************/


/******************************************************************************
* defines 
******************************************************************************/

#define	TCC_LINUX_FILE_SYTEM

//#define	TCC_FILE_DEBUG	// for Telechips File Systme Debugging 

#ifdef TCC_LINUX_FILE_SYTEM
#define	TCC_FILE			FILE					// File Handler

#define	TCC_SEEK_SET		SEEK_SET				// File Seek 
#define	TCC_SEEK_CUR		SEEK_CUR			//
#define	TCC_SEEK_END		SEEK_END			//

#define	TCC_FILE_OK			0
#define	TCC_FILE_ERROR		-1					
#define	TCC_FILE_EOF		EOF
#else

#endif

#define TCC_SUBTITLE_FILEIO_DEBUG	0

#define	TC_SEEK_SET	0
#define	TC_SEEK_CUR	1
#define	TC_SEEK_END	2

#define TRUE 1
#define FALSE 0

//	Container   ʿ
#define	USE_DMP_IO_CORRECTION

//#define	TCC_FILE_NOT_WRITE
//#define	TCC_FILE_PERFORMANCE_TEST			//ӵ, Writeӵ.
//#define	TCC_FILE_PERFORMANCE_TEST_USERFILE 	//user recording  ӵ .
//#define	TCC_FILE_PERFORMANCE_TEST_LOG_TIME 1000 * 2 // 2 min

typedef struct tagStreamBufferManager
{
	char strurl[1024];

	int bEOF;
#ifdef USE_DMP_IO_CORRECTION
	int bSeekFail;
#endif
	int bOpened;
	int DLNAReaderID;
	long long llCurrentPos;
	long long llDuration;
	long long llContentsSize;
	long long llOverflowSize;
	FILE* fp;
}StreamBufferManager_t;

typedef struct TCC_File_Handler_structure
{
	int		m_iHandler;			//	fp (Ʈ 쿡 StreamBufferManager_t ü ּҷ Ѵ.
	int	 	m_iHandler_Type;	//	stream or file

	//	for debug
//	long long	m_llGet_CurPos;		//	get function fp
//	int			m_iGet_Size;		//	Read or Seek move size

	struct	TCC_File_Handler_structure	*prev;
	struct	TCC_File_Handler_structure	*next;
	
}TCC_File_Handler_t, *pTCC_File_Handler_t;

typedef struct TCC_Multi_File_Handler_structure
{
	TCC_File_Handler_t *head;
	TCC_File_Handler_t *tail;	
	int			m_iHandler_Cnt;
}TCC_Multi_File_Handler_t, *pTCC_Multi_File_Handler_t;

/******************************************************************************
* globals
******************************************************************************/
int 			_llPos;
int 	_llLength;

/******************************************************************************
* locals
******************************************************************************/


/******************************************************************************
* declarations
******************************************************************************/
extern TCC_FILE	 *TCC_fopen(char *path,char *mode);
extern TCC_FILE	 *TCC_camera_fopen(char *path,char *mode);
extern int TCC_fclose(TCC_FILE *stream);
extern int TCC_fseek(TCC_FILE *stream, long offset, int whence);
extern long  TCC_ftell(TCC_FILE *stream);
extern void  TCC_rewind(TCC_FILE *stream);
extern int TCC_feof(TCC_FILE *stream);
extern int TCC_fgetc(TCC_FILE *stream);
extern char *TCC_fgets(char *s, int size, TCC_FILE *stream);
extern int TCC_fputs(char *s, TCC_FILE *stream);
extern int TCC_fread(char *s, int size_t, int size, TCC_FILE *stream);
extern int TCC_fread_for_demuxer(char *s, int size_t, int size, TCC_FILE *stream);
extern int TCC_fwrite(char *s, int size_t, int size, TCC_FILE *stream);
extern int TCC_fseeko (TCC_FILE *stream, off_t offset, int whence); 
extern off_t TCC_ftello(TCC_FILE *stream);
extern int TCC_fflush(TCC_FILE *stream);
extern int TCC_ffclose(TCC_FILE *stream);

extern void TCC_fStartMeasure(void);
extern void TCC_fWriteToFile(char *filename);
extern void TCC_fWriteToLog(void);
extern void TCC_PrefMeasure_Start(char* filename);

extern int 	TC_Read(int iHandle, void *pBuff, unsigned int iCount);
extern int 	TC_Seek(int iHandle, int iOffset, unsigned int iOrigin);
extern int	TC_Tell(int Instream);

TCC_Multi_File_Handler_t *TCC_Multi_File_Get_Handler( void);
int TCC_Multi_File_Init_Handler( void);
int TCC_Multi_File_Deinit_Handler( void);
int TCC_Multi_File_Insert_Handler(int fp, int type);
int TCC_Multi_File_Remove_Handler(int fp);
int TCC_Multi_File_Get_Handler_Type( int fp );
int TCC_Multi_File_Get_Total_Handler_Num( void);

#endif //_TCC_FILE_H__
