/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : tcc_gps_userdata.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/
#ifndef 	__TCC_GPS_USERDATA_H__
#define 	__TCC_GPS_USERDATA_H__
/******************************************************************************
* include 
******************************************************************************/
#include <sys/time.h>

/******************************************************************************
* defines 
******************************************************************************/

#ifndef TRUE
#define TRUE                1
#endif

#ifndef FALSE
#define FALSE               0
#endif


/******************************************************************************
* typedefs & structure
******************************************************************************/

typedef struct tagDATEInfo
{
	int Year;
	int Month;
	int Day;
} DATEInfo;

typedef struct tagTIMEInfo
{
    int     Hour;       /**< Hours since midnight - [0,23] */
    int     Min;        /**< Minutes after the hour - [0,59] */
    int     Sec;        /**< Seconds after the minute - [0,59] */
    int     HSec;       /**< Hundredth part of second - [0,99] */
} TIMEInfo;

#if 0

typedef struct tagINFGPSXYZ
{
	double latitude;	// GPGGA.Latitude
	double longitude;	// GPGGA.Longitude
	double altitude;	// GPGGA.AntennaAltitude
	double speed;		// GPRMC.Speed, 1 Knots = 1.852km/h
	double course;		// GPRMC.Direction
	double time;		// GPGGA.DGPS_Age
	char geoid;		// GPGGA.GeoidalSeparationUnits
	double hdop;		// GPGGA.HDOP
	int satellites;		// GPGGA.UsedSatellites 	
	int quality;		// GPGGA.Signal
	char valid;		// GPRMC.Status
	int system;		// ?
	TIMEInfo gmt;		// GPGGA.UTC
	DATEInfo date;		// GPRMC.Day
	struct timeval timestamp;
}INFGPSXYZ_t;

#else

typedef struct tagINFGPSXYZ
{
	double latitude;	// GPGGA.Latitude
	double longitude;	// GPGGA.Longitude
	double altitude;	// GPGGA.AntennaAltitude
	double speed;	// GPRMC.Speed, 1 Knots = 1.852km/h
	double hdop;		// GPGGA.HDOP
	int satellites;		// GPGGA.UsedSatellites 	
	char north_south;	// GPRMC.NorthSouth	[N]orth or [S]outh
	char east_west;	// GPRMC.EastWest		[E]ast or [W]est
	char valid;		// GPRMC.Status
	TIMEInfo gmt;	// GPGGA.UTC
	DATEInfo date;	// GPRMC.Day
	struct timeval timestamp;
}INFGPSXYZ_t;

#endif
/******************************************************************************
* globals
******************************************************************************/

/******************************************************************************
* locals
******************************************************************************/

/******************************************************************************
* declarations
******************************************************************************/


#endif	//	 __TCC_GPS_USERDATA_H__