/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : tcc_gsensor_process.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/
#ifndef 	__TCC_GSENSOR_USERDATA_H__
#define 	__TCC_GSENSOR_USERDATA_H__
/******************************************************************************
* include 
******************************************************************************/
#include <sys/time.h>

/******************************************************************************
* defines 
******************************************************************************/
#ifndef TRUE
#define TRUE                1
#endif

#ifndef FALSE
#define FALSE               0
#endif

#define GSENSOR_MAX_EVENTS		100//20//100



/******************************************************************************
* typedefs & structure
******************************************************************************/

typedef struct {
	int x;
	int y;
	int z;
	int resolution;
	int delay_time;
	struct timeval timestamp;
} tcc_sensor_accel_old_t, *ptcc_sensor_accel_old_t;


typedef struct {
	double x;
	double y;
	double z;
	int resolution;
	int delay_time;
	struct timeval timestamp;
} tcc_sensor_accel_t, *ptcc_sensor_accel_t;

typedef struct tagGSENSOR_ARRAY
{
	unsigned int dataNum;
	tcc_sensor_accel_t sensor[GSENSOR_MAX_EVENTS];
}GSENSOR_ARRAY;


/******************************************************************************
* globals
******************************************************************************/

/******************************************************************************
* locals
******************************************************************************/

/******************************************************************************
* declarations
******************************************************************************/

#endif	//	 __TCC_GSENSOR_USERDATA_H__
