/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : tcc_time.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/
#ifndef	_TCC_TIME_H__
#define	_TCC_TIME_H__


/******************************************************************************
* include 
******************************************************************************/
#include <sys/time.h>
#include <stdio.h>
#include <fcntl.h>
#include <pthread.h>


/******************************************************************************
* defines 
******************************************************************************/

#define	TCC_PROFILE_NUM 		  100
#define	TCC_PROFILE_STRING_MAX 128



/******************************************************************************
* typedefs & structure
******************************************************************************/


typedef struct TCC_Profile_Data_Struct
{
	char string[TCC_PROFILE_STRING_MAX];
	unsigned long long  time;		//micro sec
	unsigned long long  start_diff;	//micro sec
	unsigned long long  prev_diff;	//micro sec
	
}TCC_Profile_Data_t,*pTCC_Profile_Data_t;

typedef struct TCC_Profile_Struct
{
	TCC_Profile_Data_t  profile_time[TCC_PROFILE_NUM];	//micro sec
	int index;
	int end_flag;
	
}TCC_Profile_t,*pTCC_Profile_t;



/******************************************************************************
* globals
******************************************************************************/

static pthread_mutex_t TCC_Profile_Mutex;

TCC_Profile_t TCC_Profile;



/******************************************************************************
* locals
******************************************************************************/

/******************************************************************************
* declarations
******************************************************************************/
unsigned long long TCC_GetTime_MSec (void); // milli second
unsigned long long TCC_GetTime_USec (void); // micro second
unsigned long long TCC_GetTime_Sec (void); //  second
unsigned long long TCC_Start_Profile_Time(TCC_Profile_t *pProfile,char *pProfile_Name ) ;
unsigned long long TCC_Add_Profile_Time(TCC_Profile_t *pProfile,char * pProfile_Name);
unsigned long long TCC_End_Profile_Time(TCC_Profile_t *pProfile,char * pProfile_Name);
void TCC_GetTime(struct timeval* now);

#endif //_TCC_TIME_H__
