/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : tcc_video_common.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/

#ifndef __TCC_VIDEO_COMMON__
#define __TCC_VIDEO_COMMON__

#include "tcc_time.h"
#include "tcc_performance.h"

//#define VIDEO_GETFRAME_TEST
//#define PERFORMANCE_MEASURE
#define TCC_VIDEO_MULTI_INSTANCE		1
#if 0
#ifdef TCC_BLACKBOX_INCLUDE
#ifdef TCC_CAMERA_EXTEND_DISPLAY_HDMI_INCLUDE
#define TCC_FB_EXTEND_DISPLAY_WIDTH 		1920
#define TCC_FB_EXTEND_DISPLAY_HEIGHT 		1080
#else
#define TCC_FB_EXTEND_DISPLAY_WIDTH 		720
#define TCC_FB_EXTEND_DISPLAY_HEIGHT 		480
#endif
#else
#define TCC_FB_EXTEND_DISPLAY_WIDTH 		1920
#define TCC_FB_EXTEND_DISPLAY_HEIGHT 		1080
#endif
#endif

#define TCC_FB_EXTEND_DISPLAY_WIDTH 		1920
#define TCC_FB_EXTEND_DISPLAY_HEIGHT 		1080

#define MAX_COMPONENT_PARSER 1

#define VIDEO_FILENAME_LEN 1024
#define EXTRADATA_SIZE 1024

#define	VIDEO_DEC_INPUT_PORT_INDEX					0	/* input port from parser component on video decoder component */
#define VIDEO_DEC_FB_OUTPUT_PORT_INDEX				1	/* output port to fbsink component on video decoder component */
#define VIDEO_DEC_CAPTURE_OUTPUT_PORT_INDEX			2	/* output port to capture component on video decoder component */

#define AUDIO_PORT_INDEX 0 /* audio port index on clock component/parser component */
#define VIDEO_PORT_INDEX 1 /* video port index on clock component/parser component */

#define PARSER_PORT_INDEX 2 /* parser port index on clock component */
#define CLOCK_PORT_INDEX 2 /* clock port index on parser component */

#define CLIENT_CLOCK_PORT_INDEX 1 /* clock port index on sink (Audio/Video) component */
#define PARSER_CLOCK_PORT_INDEX 2 /* clock port index on parser component */

#define VIQE_CLOCKPORT_INDEX 2 /* clock port index on motion detection component */
#define MOTION_DETECTION_CLOCKPORT_INDEX 2 /* clock port index on motion detection component */
#define VIDEO_STREAM 0
#define AUDIO_STREAM 1

#define AUDIO_END 0x1
#define VIDEO_END 0x2
#define AV_END 0x4

#define MKTAG(a, b, c, d) (a | (b << 8) | (c << 16) | (d << 24))

typedef enum
{
	PCM_MODE, // normal mode
	SPDIF_MODE, // not support audio mode
	PCM_BITSTREAM, // pcm + bitstream mode
	PCM_PCM_MODE,
} AUDIO_OUTPUT_MODE;


/* Video Decoder Name Definition */
#define VIDEO_DEC_BASE_NAME "OMX.tcc.video_decoder"

#define VIDEO_CDK_DEC_NAME "OMX.tcc.video_decoder.cdk"

#define VIDEO_DEC_S263_NAME "OMX.tcc.video_decoder.s263"
#define VIDEO_DEC_S263_ROLE "video_decoder.s263"

#define VIDEO_DEC_H264_NAME "OMX.tcc.video_decoder.avc"
#define VIDEO_DEC_H264_ROLE "video_decoder.avc"
#define VIDEO_DEC_TCC_H264_ROLE "video_decoder.tcc_avc"

#define VIDEO_DEC_MPEG4_NAME "OMX.tcc.video_decoder.mpeg4"
#define VIDEO_DEC_MPEG4_ROLE "video_decoder.mpeg4"

#define VIDEO_DEC_WMV_NAME "OMX.tcc.video_decoder.wmv"
#define VIDEO_DEC_WMV_ROLE "video_decoder.wmv9"

#define VIDEO_DEC_MPEG2_NAME "OMX.tcc.video_decoder.mpeg2"
#define VIDEO_DEC_MPEG2_ROLE "video_decoder.mpeg2"

#define VIDEO_DEC_RV_NAME "OMX.tcc.video_decoder.rv"
#define VIDEO_DEC_RV_ROLE "video_decoder.rv"


/* Video Parser Name Definition */
#define VIDEO_PARSER_BASE_NAME "OMX.tcc.parser"

#define VIDEO_CDK_DMX_NAME "OMX.tcc.demuxer.cdk"
#define VIDEO_VOB_DMX_NAME "OMX.tcc.demuxer.vob"

#define VIDEO_PARSER_AVI_NAME "OMX.tcc.parser.avi"
#define VIDEO_PARSER_MP4_NAME "OMX.tcc.parser.mp4"
#define VIDEO_PARSER_ASF_NAME "OMX.tcc.parser.asf"
#define VIDEO_PARSER_MPG_NAME "OMX.tcc.parser.mpg"
#define VIDEO_PARSER_RM_NAME "OMX.tcc.parser.rm"
#define VIDEO_PARSER_TS_NAME "OMX.tcc.parser.ts"
#define VIDEO_PARSER_FLV_NAME "OMX.tcc.parser.flv"
#define VIDEO_PARSER_MKV_NAME "OMX.tcc.parser.mkv"


/* WiFi Display Component Name Definition */
#define WFDSINK_DMX_NAME "OMX.tcc.wfdsink.dmx"
#define WFDSINK_VDEC_NAME "OMX.tcc.wfdsink.vdec"
#define WFDSINK_ADEC_NAME "OMX.tcc.wfdsink.adec"
#define WFDSINK_FBSINK_NAME "OMX.tcc.wfdsink.fbsink"
#define WFDSINK_ALSASINK_NAME "OMX.tcc.wfdsink.alsasink"


/* Audio Decoder Role Definition */
#define AUDIO_DEC_BASE_NAME "OMX.tcc.audio_decoder"

#define AUDIO_CDK_DEC_NAME "OMX.tcc.audio_decoder.cdk"

#define AUDIO_DEC_MP3_NAME "OMX.tcc.audio_decoder.mp3_dec"
#define AUDIO_DEC_MP3_ROLE "audio_decoder.mp3_dec"

#define AUDIO_DEC_AAC_NAME "OMX.tcc.audio_decoder.aac_dec"
#define AUDIO_DEC_AAC_ROLE "audio_decoder.aac_dec"
#define AUDIO_DEC_TCC_AAC_ROLE "audio_decoder.tcc_aac"

#define AUDIO_DEC_WMA_NAME "OMX.tcc.audio_decoder.wma_dec"
#define AUDIO_DEC_WMA_ROLE "audio_decoder.wma_dec"
#define AUDIO_DEC_TCC_WMA_ROLE "audio_decoder.tcc_wma"

#define AUDIO_DEC_MP2_NAME "OMX.tcc.audio_decoder.mp2_video"
#define AUDIO_DEC_MP2_ROLE "audio_decoder.mp2_dec"

#define AUDIO_DEC_AC3_NAME "OMX.tcc.audio_decoder.ac3_dec"
#define AUDIO_DEC_AC3_ROLE "audio_decoder.ac3_dec"

#define AUDIO_DEC_FLAC_NAME "OMX.TCC.flacdec"
#define AUDIO_DEC_FLAC_ROLE "audio_decoder.flac"

#define AUDIO_DEC_APE_NAME "OMX.TCC.apedec"
#define AUDIO_DEC_APE_ROLE "audio_decoder.ape"

#define AUDIO_DEC_VORBIS_NAME "OMX.TCC.vorbisdec"
#define AUDIO_DEC_VORBIS_ROLE "audio_decoder.vorbis"

#define AUDIO_DEC_DTS_NAME "OMX.tcc.audio_decoder.dts_dec"
#define AUDIO_DEC_DTS_ROLE "audio_decoder.dts_dec"

#define AUDIO_DEC_PCM_NAME "OMX.tcc.audio_decoder.pcm"
#define AUDIO_DEC_PCM_ROLE "audio_decoder.pcm_dec"

#define AUDIO_DEC_RA_NAME "OMX.tcc.audio_decoder.ra_dec"
#define AUDIO_DEC_RA_ROLE "audio_decoder.ra_dec"

/* A/V Rederer Name Definition */
#define FBDEV_SINK_NAME "OMX.tcc.fbdev.fbdev_sink"
#define ALSA_SINK_NAME  	"OMX.tcc.alsa.alsasink"

/* A/V Effector Name Definition */
#define AUDIO_EFFECT_VOLUME_NAME "OMX.tcc.volume.component"

/* Clock Sync Component Name Definition */
#define CLOCK_SOURCE_NAME "OMX.tcc.clocksrc"

/* VIQE Component Name Definition */
#define VIQE_COMP_NAME "OMX.tcc.video.viqe"
#define VIQE_COMP_ROLE "video.viqe"

/* Motion Detection Component Name Definition */
#define MOTION_DETECTION_COMP_NAME "OMX.tcc.video.motion_detection"
#define MOTION_DETECTION_COMP_ROLE "video.motion_detection"

/* Jpeg encoder Component Name Definition */
#define VIDEO_JPEGENC_COMP_NAME "OMX.tcc.video.jpeg_encoder"
#define VIDEO_JPEGENC_COMP_ROLE "video.jpeg_encoder"

/* when seeking & video codec is H.264, few frames should drop to prevent blocking frame. */
#define H264_SEEK_FRAMEDROP_COUNT (30)


#define TCC_VIDEO_SD_PATH "/mnt/SD0/camera/"
#define TCC_VIDEO_SD_PATH_EVENT "/mnt/SD0/camera/event/"
#define TCC_VIDEO_SD_PATH_NORMAL "/mnt/SD0/camera/normal/"
#define TCC_VIDEO_SD_PATH_PARKING "/mnt/SD0/camera/parking/"
#define TCC_VIDEO_SD_PATH_USER "/mnt/SD0/camera/user/"
#ifdef TCC_CAMERA_DETAIL_DIR_INCLUDE
#define TCC_VIDEO_SD_PATH_PICTURES "/mnt/SD0/camera/pictures/A_Camera/"  // Video -15~+15 Frame Capture Folder 
#else
#define TCC_VIDEO_SD_PATH_PICTURES "/mnt/SD0/camera/pictures/"  // Video -15~+15 Frame Capture Folder 
#endif
#define TCC_VIDEO_NAND_PATH_1 "/nand1/video/"
#define TCC_VIDEO_NAND_PATH_2 "/nand2/video/"

#define	TCC_VIDEO_CAPTURE_PRE_FIX_NAME 		"tcc_"
#define	TCC_VIDEO_CAPTURE_EXTENSION_JPEG 	".jpg"

#define LIBTCCCDKCORE_SO "libcdkcore.so"

typedef struct
{
	/* File */
	unsigned long	ulTotalTime; //ü  ð

	/*Video*/
	long			ulFcc;
	long			ulWidth;
	long			ulHeight;
	long			ulFramesPerSec;

	/*Audio*/
	long			ulFormatTag;
	long			ulSamplesPerSec;
	long			ulBitsPerSample;
	long			ulNumChannel;
	char 			szAudioLangCode[4]; //ISO 639

	/*Subtitle*/
	char 			szSubTitleLangCode[4]; //ISO 639

	/*Graphics*/
	char 			szGraphicLangCode[4]; //ISO 639
}contentInfo;

typedef enum {
	LINUX_SNOR_DONGLE = 0,

	LINUX_CCM,

	LINUX_PLATFORM,

	LINUX_NONE=0xFFFFFFFF

}WFD_PLATFORM_E;

typedef enum {

	WFD_DISPLAY_HDMI = 0,

	WFD_DISPLAY_LCD,

	WFD_DISPLAY_COMPOSITE,

	WFD_DISPLAY_NONE=0xFFFFFFFF

}WFD_DISPLAY_DEVICE_E;


typedef enum {
	COMPONENT_CDK_DEMUXER,

	COMPONENT_CDK_VIDEO_DECODER,

	COMPONENT_CDK_AUDIO_DECODER,

	COMPONENT_VOLUME,

	COMPONENT_FBDEV_SINK,
	COMPONENT_ALSA_SINK,

	COMPONENT_CLOCK_SRC,
	COMPONENT_JPEG_ENCODER,
	COMPONENT_NONE=0xFFFFFFFF

}COMPONENT_ID_E;


typedef enum {

	CODEC_ID_NONE=0,

	/* video codecs */
	CODEC_ID_MPEG1,
	CODEC_ID_MPEG2, ///< preferred ID for MPEG-1/2 video decoding
	CODEC_ID_MPEG4,
	CODEC_ID_S263,
	CODEC_ID_H264,
	CODEC_ID_RV,
	CODEC_ID_MJPEG,
	CODEC_ID_WMV,
	CODEC_ID_DIVX,
	CODEC_ID_XVID,

	/* image codec*/
	CODEC_ID_PNG,
	CODEC_ID_BMP,
	CODEC_ID_GIF,

	/* audio codecs */
	CODEC_ID_MP2,
	CODEC_ID_MP3,
	CODEC_ID_AAC,
	CODEC_ID_MPEG4AAC,
	CODEC_ID_AC3,
	CODEC_ID_DTS,
	CODEC_ID_VORBIS,
	CODEC_ID_WMA,
	CODEC_ID_FLAC,
	CODEC_ID_PCM,
	CODEC_ID_ADPCM,
	CODEC_ID_APE,
	CODEC_ID_RA,
}CODEC_ID_E ;

 typedef enum {

	PIX_FMT_NONE= -1,
	PIX_FMT_YUV420P,   ///< Planar YUV 4:2:0, 12bpp, (1 Cr & Cb sample per 2x2 Y samples)
	PIX_FMT_YUYV422,   ///< Packed YUV 4:2:2, 16bpp, Y0 Cb Y1 Cr
	PIX_FMT_RGB24,     ///< Packed RGB 8:8:8, 24bpp, RGBRGB...
	PIX_FMT_BGR24,     ///< Packed RGB 8:8:8, 24bpp, BGRBGR...
	PIX_FMT_YUV422P,   ///< Planar YUV 4:2:2, 16bpp, (1 Cr & Cb sample per 2x1 Y samples)
	PIX_FMT_YUV444P,   ///< Planar YUV 4:4:4, 24bpp, (1 Cr & Cb sample per 1x1 Y samples)
	PIX_FMT_RGB32,     ///< Packed RGB 8:8:8, 32bpp, (msb)8A 8R 8G 8B(lsb), in cpu endianness
	PIX_FMT_YUV410P,   ///< Planar YUV 4:1:0,  9bpp, (1 Cr & Cb sample per 4x4 Y samples)
	PIX_FMT_YUV411P,   ///< Planar YUV 4:1:1, 12bpp, (1 Cr & Cb sample per 4x1 Y samples)
	PIX_FMT_RGB565,    ///< Packed RGB 5:6:5, 16bpp, (msb)   5R 6G 5B(lsb), in cpu endianness
	PIX_FMT_RGB555,    ///< Packed RGB 5:5:5, 16bpp, (msb)1A 5R 5G 5B(lsb), in cpu endianness most significant bit to 0
	PIX_FMT_GRAY8,     ///<        Y        ,  8bpp
	PIX_FMT_MONOWHITE, ///<        Y        ,  1bpp, 0 is white, 1 is black
	PIX_FMT_MONOBLACK, ///<        Y        ,  1bpp, 0 is black, 1 is white
	PIX_FMT_PAL8,      ///< 8 bit with PIX_FMT_RGB32 palette
	PIX_FMT_YUVJ420P,  ///< Planar YUV 4:2:0, 12bpp, full scale (jpeg)
	PIX_FMT_YUVJ422P,  ///< Planar YUV 4:2:2, 16bpp, full scale (jpeg)
	PIX_FMT_YUVJ444P,  ///< Planar YUV 4:4:4, 24bpp, full scale (jpeg)
	PIX_FMT_XVMC_MPEG2_MC,///< XVideo Motion Acceleration via common packet passing(xvmc_render.h)
	PIX_FMT_XVMC_MPEG2_IDCT,
	PIX_FMT_UYVY422,   ///< Packed YUV 4:2:2, 16bpp, Cb Y0 Cr Y1
	PIX_FMT_UYYVYY411, ///< Packed YUV 4:1:1, 12bpp, Cb Y0 Y1 Cr Y2 Y3
	PIX_FMT_BGR32,     ///< Packed RGB 8:8:8, 32bpp, (msb)8A 8B 8G 8R(lsb), in cpu endianness
	PIX_FMT_BGR565,    ///< Packed RGB 5:6:5, 16bpp, (msb)   5B 6G 5R(lsb), in cpu endianness
	PIX_FMT_BGR555,    ///< Packed RGB 5:5:5, 16bpp, (msb)1A 5B 5G 5R(lsb), in cpu endianness most significant bit to 1
	PIX_FMT_BGR8,      ///< Packed RGB 3:3:2,  8bpp, (msb)2B 3G 3R(lsb)
	PIX_FMT_BGR4,      ///< Packed RGB 1:2:1,  4bpp, (msb)1B 2G 1R(lsb)
	PIX_FMT_BGR4_BYTE, ///< Packed RGB 1:2:1,  8bpp, (msb)1B 2G 1R(lsb)
	PIX_FMT_RGB8,      ///< Packed RGB 3:3:2,  8bpp, (msb)2R 3G 3B(lsb)
	PIX_FMT_RGB4,      ///< Packed RGB 1:2:1,  4bpp, (msb)2R 3G 3B(lsb)
	PIX_FMT_RGB4_BYTE, ///< Packed RGB 1:2:1,  8bpp, (msb)2R 3G 3B(lsb)
	PIX_FMT_NV12,      ///< Planar YUV 4:2:0, 12bpp, 1 plane for Y and 1 for UV
	PIX_FMT_NV21,      ///< as above, but U and V bytes are swapped

	PIX_FMT_RGB32_1,   ///< Packed RGB 8:8:8, 32bpp, (msb)8R 8G 8B 8A(lsb), in cpu endianness
	PIX_FMT_BGR32_1,   ///< Packed RGB 8:8:8, 32bpp, (msb)8B 8G 8R 8A(lsb), in cpu endianness

	PIX_FMT_GRAY16BE,  ///<        Y        , 16bpp, big-endian
	PIX_FMT_GRAY16LE,  ///<        Y        , 16bpp, little-endian
	PIX_FMT_YUV440P,   ///< Planar YUV 4:4:0 (1 Cr & Cb sample per 1x2 Y samples)
	PIX_FMT_YUVJ440P,  ///< Planar YUV 4:4:0 full scale (jpeg)
	PIX_FMT_YUVA420P,  ///< Planar YUV 4:2:0, 20bpp, (1 Cr & Cb sample per 2x2 Y & A samples)
	PIX_FMT_NB,        ///< number of pixel formats, DO NOT USE THIS if you want to link with shared libav* because the number of formats might differ between versions
}PIXEL_FORMAT_E;

 typedef struct
 {
	 unsigned int		width;
	 unsigned int		height;
	 unsigned int		width_offset;
	 unsigned int		height_offset;
 }videoframeinfo;

 typedef struct
{
	unsigned int start_lba;
	unsigned int end_lba;
	unsigned int stilltime;
	unsigned int is_first_init;
	unsigned int dmx_reinit;
	unsigned int rebase_base_clock;
	unsigned short speed;
	unsigned short direction;
}TCC_DVD_PARAM_t;

 typedef struct
{
	unsigned int is_step_mode;
}TCC_VIDEO_STEP_t;

 typedef struct
{
	unsigned int currentstate;
	unsigned int ScreenMode;
}TCC_VIDEO_SET_SCREENMODE_t;

 typedef struct
{
	unsigned int src_width;
	unsigned int src_height;
}TCC_VIDEO_SET_RESOLUTION_t;

 typedef struct
{
	unsigned int refresh_flag;
	unsigned int audio_stream_index;
}TCC_DVD_REFRESH_INFO_t;

 typedef struct
{
	unsigned int vdec_reinit;
	unsigned int m_iWidth;
	unsigned int m_iHeight;
	unsigned int m_iFrameRate;
}DVD_VIDEO_ATTR_INFO_t;

 typedef struct
{
	unsigned int adec_reinit;
	unsigned int m_iAcodecID;
	unsigned int m_iSamplePerSec;		//!< samples/sec
	unsigned int m_iBitsPerSample; 	//! bits/sample
	unsigned	int m_iChannels;			//!< channels
}DVD_AUDIO_ATTR_INFO_t;

 typedef struct
{
	unsigned int mode;
    unsigned int pos_x;
    unsigned int pos_y;
    unsigned int width;
    unsigned int height;		//!< samples/sec
	const char*  pcm_handle_name;
}OUTPUT_INFO;

typedef struct
{
	//target overlay index(0, 1)
	int index;

	//display position
	int left;
	int top;
	int right;
	int bottom;
}TCC_VIDEO_TARGET_DISPLAY_t;

typedef struct
{
	unsigned char* filename;
	unsigned int start_pts;
	unsigned int finish_pts;
	unsigned int curr_pts;
	unsigned int num_of_frame;
	unsigned int is_paused_state;
}TCC_VIDEO_CONTINUOUS_CAPTURE_t;

typedef enum
{
	CAPTURE_IMAGE_FORMAT_MIN = 0,
	CAPTURE_IMAGE_FORMAT_RGB565,
	CAPTURE_IMAGE_FORMAT_RGB888,
	CAPTURE_IMAGE_FORMAT_RGBA,

	CAPTURE_IMAGE_FORMAT_JPEG,
	CAPTURE_IMAGE_FORMAT_BMP,
	CAPTURE_IMAGE_FORMAT_PNG,
	CAPTURE_IMAGE_FORMAT_GIF,
	CAPTURE_IMAGE_FORMAT_MAX
}CaptureImageFormat;

typedef struct _struct_subtitle_stream_t
{
	unsigned char  *m_pbyStreamData;		//!< [out] the pointer to outstream data
	unsigned short *m_pCaption;			//pointer to Caption image buffer
	unsigned long	m_ulStreamDataSize;		//!< [out] the size to outstream data
	/*for image Subtitle*/
	unsigned int 	m_uiWidth;//width of Caption image buffer
	unsigned int	m_uiHeight;//height of Caption image buffer
	unsigned int	m_uiOffsetX;
	unsigned int	m_uiOffsetY;
	unsigned long	m_ulStartTimeStamp;			//!< [out] the timestamp of outstream
	unsigned long	m_ulEndTimeStamp;		//!< [out] the end timestamp of outstream: This is not mandatory except in the case of text-subtitle
	unsigned long	m_ulSubtitleFormat;		//!Subtitle Format
	void		   *m_pSpecificData;		//!< [out] the pointer to specific output of demuxer(if demuxer has a specific data)
} subtitle_stream_t;


typedef struct
{
	unsigned long long	   system_base_clocks;
	unsigned long long	   media_base_clocks;
}BaseClockInfo;

#define DBG_LINE()		printf("[%d][%s]\n", __LINE__, __FUNCTION__);
#define DBG(fmt, args...) 			do{ printf("[%s][%d]" fmt, __FUNCTION__, __LINE__, ## args); }while(0)

#define LIKELY(x)       __builtin_expect((x),1)
#define UNLIKELY(x)     __builtin_expect((x),0)

#define SUBTITLE_FMT_SRT		0 // SRT subtitle
#define SUBTITLE_FMT_SSA		1 // SSA subtitle
#define SUBTITLE_FMT_USF		2 // Universal Subtitle Format
#define SUBTITLE_FMT_BMP		3 // BMP
#define SUBTITLE_FMT_VOBSUB	4 // VOBSUB
#define SUBTITLE_FMT_KATE		5 // KATE
#define SUBTITLE_FMT_TSPGS		6 // TS Presentation Graphic Stream

#define VIDEO_DECODER_CHROMA_INTERLEAVE			1

#endif /*__TCC_VIDEO_COMMON__*/
