/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*
*  This material is confidential and shall remain as such.
*  Any unauthorized use, distribution, reproduction is strictly prohibited.
*
*   FileName    : TCCUtil.h
*   Description :
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/
#ifndef _VIRTUAL_H__
#define _VIRTUAL_H__

/******************************************************************************
* include
******************************************************************************/
#include <globals.h>


#define TCC_MEMORY_DEVICE_NAME "/dev/mem"
#define TCC_VIRTUAL_DEVICE_NAME_SIZE 128


/******************************************************************************
* typedefs & structure
******************************************************************************/

typedef struct _DEC_MEM_SET
{
	unsigned int OutputBufferBase;
	unsigned int OutputBufferSize;
	unsigned int InputBufferBase;
	unsigned int InputBufferSize;
	unsigned int DataBufferBase;
	unsigned int DataBufferSize;
} DEC_MEM_SET; // Decoder(Subcore) Physical Memory Base Setting

typedef struct Virtual_Structrue
{
	char device_name[TCC_VIRTUAL_DEVICE_NAME_SIZE];
	int fd; // Virtual File Handler
} Virtual_t;


/******************************************************************************
* globals
******************************************************************************/


/******************************************************************************
* locals
******************************************************************************/

/******************************************************************************
* declarations
******************************************************************************/
int Init_Virtual(Virtual_t *virtual, char *device_name);
int DeInit_Virtual(Virtual_t *virtual);
void *SetVirtual(Virtual_t *virtual, unsigned int physical_addr, unsigned int mem_size);
int FreeVirtual(Virtual_t *virtual,void *virtual_ptr, unsigned int mem_size);

void *sys_malloc_virtual_addr(int *pDev, unsigned int PAddr, unsigned int uiSize);
void sys_free_virtual_addr(int *pDev, void *virtual_ptr, unsigned int mem_size);
void *sys_malloc_physical_addr(unsigned int uiSize);
void sys_free_physical_addr(void *pPtr, unsigned int uiSize);
int sys_init_physical_addr_size_for_capture(unsigned int *pPhysicalBaseAddr, unsigned int *pPhysicalBaseSize);

#endif //_VIRTUAL_H__
