/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*                                   
*  This material is confidential and shall remain as such. 
*  Any unauthorized use, distribution, reproduction is strictly prohibited. 
*
*   FileName    : tcc_composite_interface.h
*   Description : 
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/
#ifndef __TCC_COMPOSITE_INTERFACE_H__
#define __TCC_COMPOSITE_INTERFACE_H__
/******************************************************************************
* include 
******************************************************************************/
#ifdef TCC_892X_INCLUDE
#include "tccfb_ioctrl.h"
#endif

#include "tcc_composite_ioctl.h"


/******************************************************************************
* defines 
******************************************************************************/
#define TCC_COMPOSITE_DEVICE		"/dev/composite"

#define TCC_COMPOSITE_ERROR_NONE				0
#define TCC_COMPOSITE_ERROR_SCREEN_INFO		-1
#define TCC_COMPOSITE_ERROR_INVALID_HANDLE	-2
#define TCC_COMPOSITE_ERROR_SET_DISABLE		-3

/******************************************************************************
* typedefs & structure
******************************************************************************/
typedef struct tagcompositeAddressRect
{
	int addr_y;
	int addr_u;
	int addr_v;
	unsigned int x_offset;
	unsigned int y_offset;
	unsigned int input_src_width;
	unsigned int input_src_height;
	unsigned int input_dest_width;
	unsigned int input_dest_height;
	unsigned int layer;
	unsigned int enable;
}composite_address_rect_t;

/******************************************************************************
* globals
******************************************************************************/


/******************************************************************************
* locals
******************************************************************************/

/******************************************************************************
* declarations
******************************************************************************/
void tcc_composite_image_display_update(int fd_handle, composite_address_rect_t *src);
int tcc_composite_video_display_update(unsigned int composite_fd, composite_address_rect_t *src);
void tcc_composite_image_display_update_yuv420sq(int fd_handle, composite_address_rect_t *src);
int tcc_composite_display_disable(unsigned int composite_fd, int layer);

int  tcc_composite_open(char* framebuffer);
int  tcc_composite_disable(unsigned int fb_dev_fd);
int  tcc_composite_close(unsigned int fb_dev_fd);




#endif //__TCC_COMPOSITE_INTERFACE_H__


