/****************************************************************************
 *	 TCC Version 0.6
 *	 Copyright (c) telechips, Inc.
 *	 ALL RIGHTS RESERVED
 *
****************************************************************************/

#ifndef _TCC_EXTOUT_TINYPROC_IOCTL_H
#define _TCC_EXTOUT_TINYPROC_IOCTL_H

#include <linux/types.h>
#include <sys/ioctl.h>
#include <fcntl.h>

#define TCC_EXT_TINY_PROC_DEV_NAME 		"/dev/extout_tiny_proc"


#define TCC_EXTOUT_TINYPROC_IOCTL_MAGIC	'p'

#define TCC_EXTOUT_PROPERTY_KEY_MAX   60
#define TCC_EXTOUT_PROPERTY_VALUE_MAX  92
#define TCC_EXTOUT_PROPERTY_MAX	100


typedef struct
{
	int cmd;
	int value;
}__attribute__((packed)) tcc_extout_tinyproc_info;


typedef enum
{
	CONFIG_OUTPUT_MODE = 0,
	CONFIG_COMPOSITE_MODE,
	CONFIG_COMPOSITE_RESIZE,
	CONFIG_COMPOSITE_DETECTED,
	CONFIG_HDMI_RESOLUTION,
	CONFIG_HDMI_AUTO_SELECT, //CONFIG_HDMI_AUDIO_SELECT
	CONFIG_HDMI_RESIZE,
	CONFIG_HDMI_DETECTED,
	CONFIG_HDMI_720P_FIXED,
	CONFIG_COMPONENT_DETECTED,
	CONFIG_SPDIF_SETTING,
	CONFIG_AUDIO_SAMPLERAGE,
	CONFIG_REQUEST_CONFIRM,
	CONFIG_MAX_NUM
};



/* ioctl for ext out tiny proc */
#define TCC_EXTOUT_TINYPROC_IOCTL_SET_CONFIG		_IOW(TCC_EXTOUT_TINYPROC_IOCTL_MAGIC, 11,tcc_extout_tinyproc_info)
#define TCC_EXTOUT_TINYPROC_IOCTL_GET_CONFIG		_IOR(TCC_EXTOUT_TINYPROC_IOCTL_MAGIC, 12,tcc_extout_tinyproc_info)

#define TCC_EXTOUT_TINYPROC_MAX_NR			20



#endif /* _TCC_EXTOUT_TINYPROC_IOCTL_H */

