/******************************************************************************
*
*  (C)Copyright All Rights Reserved by Telechips Inc.
*
*  This material is confidential and shall remain as such.
*  Any unauthorized use, distribution, reproduction is strictly prohibited.
*
*   FileName    : tcc_fb_interface.h
*   Description :
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*******************************************************************************/
#ifndef	_TCC_FB_INTERFACE_H__
#define	_TCC_FB_INTERFACE_H__


/******************************************************************************
* include
******************************************************************************/
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <linux/fb.h>
#include <linux/videodev2.h>
#include "tccfb_ioctrl.h"

/******************************************************************************
* defines
******************************************************************************/
#define TCC_FB0_DEV_NAME 			"/dev/fb0"


#define TCC_FB_ERROR_NONE				0
#define TCC_FB_ERROR_SCREEN_INFO		-1
#define TCC_FB_ERROR_INVALID_HANDLE		-2
#define TCC_FB_ERROR_SET_DISABLE		-3

#if TCC_BLACKBOX_GUI_SCALING_INCLUDE
#define TCC_FB_SCALE_FB_WIDTH 720
#define TCC_FB_SCALE_FB_HEIGHT 480
#define TCC_FB_SCALE_REDUCE_FACTOR 3
#endif



/******************************************************************************
* typedefs & structure
******************************************************************************/
typedef enum
{
	TCC_FB_16BIT_MODE = 0,
	TCC_FB_32BIT_MODE
}TCC_FB_TYPE;



/******************************************************************************
* globals
******************************************************************************/


/******************************************************************************
* locals
******************************************************************************/

/******************************************************************************
* declarations
******************************************************************************/

int tcc_fb_open(char *framebuffer);
int tcc_fb_close(unsigned int fb_dev_fd);
int tcc_fb_clear(char *framebuffer);
int tcc_fb_set_fb_bits_per_pixel(int mode, char *framebuffer);
int tcc_fb_get_vscreen_info(int fbdev, struct fb_var_screeninfo *screen_info);
int tcc_fb_set_vscreen_info(int fbdev, struct fb_var_screeninfo *screen_info);
int tcc_fb_push_vsync(int fbdev, struct tcc_lcdc_image_update *lcdc_display);
int tcc_fb_end_vsync(int fbdev);
int tcc_fb_start_vsync(int fbdev, int framecnt);
int tcc_fb_set_framerate_vsync(int fbdev, int framerate);
int tcc_fb_get_fscreen_info(int fbdev, struct fb_fix_screeninfo *screen_info);
int tcc_fb_pan_display_update(int fbdev, struct fb_var_screeninfo *screen_info);
int tcc_fb_display(unsigned int fb_dev_fd);


#endif //_TCC_FB_INTERFACE_H__
