#define VIQE_DEV_NAME		"viqe"
#define VIQE_DEV_MAJOR		230
#define VIQE_DEV_MINOR		0

#define IOCTL_VIQE_INITIALIZE		0xAF0
#define IOCTL_VIQE_EXCUTE			0xAF1
#define IOCTL_VIQE_DEINITIALIZE		0xAF2
#define IOCTL_VIQE_SETTING			0xAF3

#define	IOCTL_VIQE_HISTOGRAM_INIT		0xBF0
#define IOCTL_VIQE_HISTOGRAM_DEINIT		0xBF1
#define	IOCTL_VIQE_HISTOGRAM_SETPARAM	0xBF2
#define	IOCTL_VIQE_HISTOGRAM_GETPARAM	0xBF3
#define	IOCTL_VIQE_HISTOGRAM_EXECUTE	0xBF4

#define	IOCTL_VIQE_DEINTERLACER_INIT		0xCF0
#define IOCTL_VIQE_DEINTERLACER_DEINIT		0xCF1
#define	IOCTL_VIQE_DEINTERLACER_SETPARAM	0xCF2
#define	IOCTL_VIQE_DEINTERLACER_GETPARAM	0xCF3
#define	IOCTL_VIQE_DEINTERLACER_EXECUTE		0xCF4
#define	IOCTL_VIQE_DEINTERLACER_SETFRAME	0xCF5


/*****************************************************************************
*
* structures
*
******************************************************************************/
#if 1//defined(CONFIG_TCC_NOT_ANDROID)
typedef struct
{
    unsigned int    idx;
    unsigned int    width;
    unsigned int    height;
    unsigned int    base0;
	unsigned int    base1;
	unsigned int    base2;
    unsigned int    imgfmt;
}VIQE_DMAPARAM;

typedef struct
{
	unsigned int	inpath; 	// 0:RDMA14, 1:VIN3
	unsigned int	width;		// VIQE_CTRL
	unsigned int	height;
	unsigned int	hoff;		// HIS_CONFIG
	unsigned int	voff;
	unsigned int	samplesize;
	unsigned int	xstart;		// Region
	unsigned int	xend;
	unsigned int	ystart;
	unsigned int	yend;
	unsigned char	seg[16];
	unsigned char	scale[16];
	unsigned char	lut[256];
	VIQE_DMAPARAM	stDMA;
}VIQE_HI_TYPE;


typedef struct
{
	int RDMAnum;
	unsigned int srcWidth;
	unsigned int srcHeight;
	unsigned int crop_top;
	unsigned int crop_bottom;
	unsigned int crop_left;
	unsigned int crop_right;
	int OddFirst;
}VIQE_DI_TYPE;


typedef struct {
	unsigned int width;
	unsigned int height;
}FRAME_EXTENSION;


typedef struct{
	unsigned int	width;
	unsigned int	height;
	unsigned int	baseaddr0;
	unsigned int	baseaddr1;
	unsigned int	baseaddr2;
	unsigned int	imgfmt;
}VIQE_DI_DMA;

typedef struct
{
	// Initialization parameter
	int OddFirst;
	int y2rconv;
	int di_mode;
	int frame_num;
	int frame_idx;
	FRAME_EXTENSION	ext_frm[3];
	VIQE_DI_DMA	SrcParam;
	VIQE_DI_DMA	DstParam;
}VIQE_DI_PARAM;

typedef struct
{
	int RDMAnum;
	unsigned int scalerCh;
	unsigned int useWMIXER;
	unsigned int srcWidth;
	unsigned int srcHeight;
	unsigned int crop_top;
	unsigned int crop_bottom;
	unsigned int crop_left;
	unsigned int crop_right;
	int OddFirst;
}VIQE_DI_ARGS;

#else
typedef struct
{
	int lcdCtrlNo;
	int scalerCh;
	int onTheFly;
	unsigned int useWMIXER;
	unsigned int srcWidth;
	unsigned int srcHeight;
	unsigned int crop_top, crop_bottom, crop_left, crop_right;
	int deinterlaceM2M;
	int renderCnt;
	int OddFirst;
	int DI_use;

	unsigned int address[6];
	unsigned int dstAddr;
}VIQE_DI_TYPE;
#endif
