/****************************************************************************
*   FileName    : omx_tcc_index.h
*   Description : 
****************************************************************************
*
*   TCC Version 1.0
*   Copyright (c) Telechips, Inc.
*   ALL RIGHTS RESERVED
*
****************************************************************************/

/****************************************************************************

Revision History

****************************************************************************

****************************************************************************/

#ifndef __TCC_OMX_INDEX_H__
#define __TCC_OMX_INDEX_H__

#include "main.h"

#ifdef TCC_ANDROID_INCLUDE
// android support
#define PV_OMX_COMPONENT_CAPABILITY_TYPE_INDEX 0xFF7A347
#endif

typedef enum{
	OMX_SPDIF_IDLE = 0,
	OMX_SPDIF_EXCUTE,
	OMX_SPDIF_PAUSE,
}SPDIF_STATE_TYPE;

typedef enum{
	// telechips vendor index Audio add.
	OMX_IndexVendorParamFileOpen = 0x7F000001,
	OMX_IndexVendorParamMediaInfo,
	OMX_IndexVendorConfigPowerSpectrum,
	OMX_IndexVendorConfigEnergyVolume,
	OMX_IndexVendorParamSetOutputMode,
	OMX_IndexVendorConfigAlsaConfigureRequest,
	OMX_IndexVendorConfigAudioScan,
	OMX_IndexVendorConfigDynamic_Range,
	OMX_IndexVendorConfigDynamic_AlsaOpen,
	OMX_IndexVendorConfigSpdifPathMode,
	OMX_IndexVendorConfigAlsaStatus,
	OMX_IndexVendorConfigExtramodeset,
	OMX_IndexVendorConfigMultiLanguage,
	OMX_IndexVendorParamErrorDetectMode,
	OMX_IndexVendorConfigFastStop,
	OMX_IndexVendorConfigClockBufferClear,
	OMX_IndexVendorConfigSeekMode,
	OMX_IndexVendorParamJpeg,
	OMX_IndexVendorParamImageInfo,
	OMX_IndexVendorParamAudioAacDualMono,
	OMX_IndexVendorParamSetAudioPause,
	OMX_IndexVendorParamAlsaSinkSetVolume,
	OMX_IndexVendorParamAlsaSinkMute,
	OMX_IndexVendorParamSetSinkByPass,
	OMX_IndexVendorParamStopRequest,
	OMX_IndexVendorNotifyStartTimeSyncWithVideo,
	OMX_IndexVendorParamSetEnableAudioStartSyncWithVideo,
	OMX_IndexVendorParamSetPatternToCheckPTSnSTC,
	
	//    
	OMX_IndexVendorOpenCodec,
	OMX_IndexVendorCloseCodec,	// delete.
	OMX_IndexVendorGetTime,
	OMX_IndexVendorFileOpen,	// delete
	OMX_IndexVendorFileClose,	// delete

	// for DEQ
	OMX_IndexVendorConfigDeqOnOff,
	OMX_IndexVendorConfigDeqMode,
	OMX_IndexVendorConfigSRSOnOff,
	OMX_IndexVendorConfigSRSMode,

	// for rec
	OMX_IndexVendorParamSetFilePath,
	OMX_IndexVendorParamSetBitrate,
	OMX_IndexVendorParamSetRecFileFormat,
	OMX_IndexVendorParamRecend,
	OMX_IndexVendorParamRecHeaderData,
	OMX_IndexVenderConfigSetEnocdeCodecType,
	OMX_IndexVenderConfigSetAACHeaderType,
	OMX_IndexVenderConfigGetPcmAverage,
	OMX_IndexVenderConfigSetSubtype,
	OMX_IndexVenderConfigGetVaildSize,
	OMX_IndexVenderConfigSetVaildSize,

	//for Camrec
	OMX_IndexVendorParamMuxType,
	OMX_IndexVendorParamCameraSrcInfo,	//	video / audio source info
	OMX_IndexVendorParamGetCameraEncInfo,	//	video / audio encoder info
	OMX_IndexVendorParamCameraMuxInfo,	//	video / audio muxer info
	OMX_IndexVendorParamCameraSetAudioCodec,
	OMX_IndexVendorParamCameraSetVideoCodec,
	OMX_IndexVendorConfigCameraFrameResolution,
	OMX_IndexVendorConfigCameraSrcInfo,
	OMX_IndexVendorConfigCameraSetBitrate,				
	OMX_IndexVendorConfigCameraSetFramerate,			
	OMX_IndexVendorConfigCameraSetKeyFrameInterval,		
	OMX_IndexVendorConfigCameraSetMotionDetectionConfig, // motion detection configuration
	OMX_IndexVendorConfigCameraSetMotionDetectionEvent,	//	motion detection start
	OMX_IndexVendorConfigCameraSetMotionDetectionSendMsgClear,	//	motion detection each channel
	OMX_IndexVendorConfigCameraSetMotionDetectionSendMsgDisable,	
	OMX_IndexVendorConfigCameraSetMotionDetectionSendMsgEnable,
	OMX_IndexVendorConfigCameraSetMotionCheckSkip,
	OMX_IndexVendorConfigCameraSetJPEGEncCaptureEn, // jpeg encoder capture enable
	OMX_IndexVendorConfigCameraSetAutoJPEGEncCaptureEn, // jpeg encoder Auto capture enable
	OMX_IndexVendorConfigCameraJPEGChangeDeviceForWrite,
	OMX_IndexVendorConfigEmergencyEvent,		
	OMX_IndexVendorConfigExitBreak,	
	OMX_IndexVendorConfigSetEmergencyFrameCount,	
	OMX_IndexVendorConfigSetAutoRecordingTime,	
	OMX_IndexVendorConfigCameraSetFileName,
	OMX_IndexVendorConfigAutoRecordingEvent,		
	OMX_IndexVendorConfigNormalRecordingEvent,
	OMX_IndexVendorConfigNormalRecordingName,
	OMX_IndexVendorConfigEventRecordingName,
	OMX_IndexVendorConfigCameraAudioSamplingrate,
	OMX_IndexVendorConfigCameraAudioInfoToMuxer,
	OMX_IndexVendorConfigCameraNoAudio,
	OMX_IndexVendorConfigCameraMuteAudio,
//	OMX_IndexVendorConfigCameraWriteUserData,
	OMX_IndexVendorConfigCameraGsensorDetected,
	OMX_IndexVendorConfigCameraSendGSensorInfo,
	OMX_IndexVendorConfigCameraSendGPSInfo,
	OMX_IndexVendorConfigSetVideoBitrate,
	OMX_IndexVendorConfigCameraSetEventStartTime,
	OMX_IndexVendorConfigCameraSetEventEndTime,
	OMX_IndexVendorConfigCameraSetEventTotalTime,
	OMX_IndexVendorConfigDisplayMode,	//	VERTICAL, HORIZONTAL, Front, Rear
	OMX_IndexVendorConfigWaitEventRecording,
	OMX_IndexVendorConfigGetCurrentRecordingTime,
	OMX_IndexVendorConfigGetCurrentEventTime,
	OMX_IndexVendorConfigAddedEventRecordingTime,
	OMX_IndexVendorParamCameraDriverOpen,
	OMX_IndexVendorParamCameraDriverClose,
	OMX_IndexVendorParamCameraDriverPreOpen,
	OMX_IndexVendorConfigBufferIndexClear,
	OMX_IndexVendorConfigCameraSrcStartConfirm,	
	OMX_IndexVendorConfigSetAlsaStart,
	OMX_IndexVendorConfigSetMuxerAllow,
	
	// for video
	OMX_IndexVendorStreamFromMP4, // h264 decoder should know PARSER
	OMX_IndexVendorFBSinkScreenMode, // fbsink screen mode
	OMX_IndexVendorFBSinkSetResolution,
	OMX_IndexVendorFBSinkSetPanScanOffset, // fbsink screen mode
	OMX_IndexVendorClockPortsUsed,	
	OMX_IndexVendorClearClockPortsUsed,
	OMX_IndexVendorFBSinkSclaeroffsetX,
	OMX_IndexVendorFBSinkSclaeroffsetY,
	OMX_IndexVendorGetframesize,
	OMX_IndexVendorMpeg2GetOneFrameMode,
	OMX_IndexVendorGetRMVideoFormatInfo,	
	OMX_IndexVendorClearEOSFlags, //[dvd] mpg parser  : for new start lba (MPG_OP_REFRESH)
	OMX_IndexVendorSetDVDmode, //[dvd] mpg parser  
	OMX_IndexVendorSetDVDParserReInit,
	OMX_IndexVendorSetDVDSubtitleonoff,
	OMX_IndexVendorSetDVDSubtitle,
	OMX_IndexVendorSetDVDAudioStream,
	OMX_IndexVendorSetStep,	
	OMX_IndexVendorSetSlow,	
	OMX_IndexVenderParamSetFbScanMode,
	OMX_IndexVenderTimeBreakSleep,
	OMX_IndexVendorFBSinkSetYUVOutMode,
	OMX_IndexVendorMeasureStart,	
	OMX_IndexVenderResetMinStartTime,
	OMX_IndexVenderNoAudioFrame,
	OMX_IndexVendorParamCDKDMXInfo,
	OMX_IndexVendorParamCDKContainerType,
	OMX_IndexVendorConfigDemuxerEOFState,	
	OMX_IndexVendorChangeResolution, // get VPU resolution and set fbsink comp. resolution.
	OMX_IndexVendorChangeDestinationResolution,	 
	OMX_IndexVendorQueueVpuDisplayIndex,
	OMX_IndexVendorParamGetOneFrameMode,
	OMX_IndexVendorDemuxStreamType,
	OMX_IndexVendorConfigDisplayIFrameNum,
	OMX_IndexVendorConfigSearchSkipTime,
	OMX_IndexVendorConfigIFrameDispTime,
	OMX_IndexVendorConfigCurrentKeyFramePTS,
	OMX_IndexVendorConfigPlaySpeed,
	OMX_IndexVendorConfigDemuxAccurateSeekMode,
	OMX_IndexVendorConfigDiscardFrame,
	OMX_IndexVendorConfigStepCount,	
	OMX_IndexVendorConfigGetCapture,
	OMX_IndexVendorConfigGetWallTimeBase,
	OMX_IndexVendorParamVideoLastKeyFrameTime,
	OMX_IndexVendorConfigSendSyncFlag,
	OMX_IndexVendorConfigSendKeyFrame,
	OMX_IndexVendorParamNotSupportAudio,
	OMX_IndexVendorSetVideoPlaymode,
	OMX_IndexVendorConfigSetSeekSync,
	OMX_IndexVendorConfigSeekWaitMask,
	OMX_IndexVendorConfigDoAVPause,
	OMX_IndexVendorConfigDoAVSync,
	OMX_IndexVendorConfigDoForceAudioSleep,
	OMX_IndexVendorConfigMediaTimeBase,
	OMX_IndexVendorConfigAppStepSemaphore,
	OMX_IndexVendorConfigSetSeekStart,
	OMX_IndexVendorConfigFlushDecoderInputBuffer,
	OMX_IndexVendorConfigSendFirstFrameForSEQHDR,
	OMX_IndexVendorConfigSendIFrameSearchEvent,
	OMX_IndexVendorConfigWaitIFrameSearchEvent,
	OMX_IndexVendorConfigPauseWaitMask,
	OMX_IndexVendorConfigDoAlsaSleep,/*IRIVER*/
	OMX_IndexVendorConfigScanMode,
	OMX_IndexVendorConfigEnableSubtitleProcess,
	OMX_IndexVenderConfigRealScanSpeedLimit,
	OMX_IndexVenderConfigWeightedPrediction,
	OMX_IndexVenderConfigCurrentDispTime,	
	OMX_IndexVendorConfigCurrentPTS,
	OMX_IndecVendroParamNalAudSet,	
	OMX_IndexVendorConfigStartConfirm,
	OMX_IndexVendorConfigSetVDtime,
	OMX_IndexVendorConfigResumeFlag,	
	OMX_IndexVendorConfigPtsView,
	OMX_IndexVendorConfigVideoZoom,
	OMX_IndexVendorConfigGetDecodingInfo,
	OMX_IndexVendorConfigContinuousCaptureStart,
	OMX_IndexVendorParamVideoFPS,
	OMX_IncdxVendorConfigPlayType,
	OMX_IncdxVendorConfigSetVideoSkip,
	OMX_IncdxVendorConfigSetIframeSearch,
	OMX_IndexVendorConfigExtendDisplayModeSet,
	OMX_IndexVendorconfigGetMediaTime,
	OMX_IndexVenderParamVideoCodec,
	OMX_Index_Vendor_ConfigAlsaRemainTime,
	OMX_IndexVendorConfigScanConfirm,
	OMX_IndexVendorParamSetVideoPause,
	OMX_IndexVendorParamIframeSearchEnable,
	OMX_IndexVendorParamVideoSurfaceState,
	OMX_IndexVendorParamDxBGetVideoInfo,
	OMX_IndexVendorSetDisplayPosition,
	OMX_IndexVendorParamSetSubtitle,
	OMX_IndexVendorParamFBCapture,
	OMX_IndexVendorParamVideoSetStart,
	OMX_IndexVendorParamSkipStartTimestamp,
	OMX_IndexVendorParamTargetDisplay, //for multi-decoding, select overlay or overlay 1
	
	// for image
	OMX_IndexVendorSetImageInfo, // for image	
	OMX_IndexVendorGetAlphaValid, //		
	OMX_IndexVendorGetGifDelay,
	OMX_IndexVendorSetDecOutDeRatio, // 	
	OMX_IndexVendorSetDecOutWidth, // 
	OMX_IndexVendorSetDecOutHeight, //	
	OMX_IndexVendorSetDecOutFormat,	
	OMX_IndexVendorSetDecOffset,	
	OMX_IndexVendorSetDecForceEnd,		
	OMX_IndexVendorSetDecflow,
	OMX_IndexVendorSetDecHwScale,

	//for DXB
	OMX_IndexVendorParamDxBGetSTCFunction,
	OMX_IndexVendorConfigSetSectionPID,
	OMX_IndexVendorConfigClearSectionPID,

	//for DXB Tuner
	OMX_IndexVendorParamSetGetPacketDataEntry,
	OMX_IndexVendorParamRecStartRequest,
	OMX_IndexVendorParamRecStopRequest,
	OMX_IndexVendorParamTunerSetNumberOfBB,
	OMX_IndexVendorParamTunerModulationSet,
	OMX_IndexVendorParamTunerGetChannelIndexByFrequency,
	OMX_IndexVendorParamTunerAnalogChannelSearch,
	OMX_IndexVendorParamTunerChannelScan,
	OMX_IndexVendorParamRegisterPID,
	OMX_IndexVendorParamUnRegisterPID,
	
	//DxB Demuxer
	OMX_IndexVendorParamDxBGetNumOfDemux,
	OMX_IndexVendorParamDxBGetCapability,
	OMX_IndexVendorParamDxBSetPath,
	OMX_IndexVendorParamDxBGetPath,
	OMX_IndexVendorParamDxBReleasePath,
	OMX_IndexVendorParamDxBStartPID,
	OMX_IndexVendorParamDxBStopPID,
	OMX_IndexVendorParamDxBRegisterPESCallback,
	OMX_IndexVendorParamDxBStartPESFilter,
	OMX_IndexVendorParamDxBStopPESFilter,
	OMX_IndexVendorParamDxBRegisterSectionCallback,
	OMX_IndexVendorParamDxBSetSectionFilter,
	OMX_IndexVendorParamDxBReleaseSectionFilter,
	OMX_IndexVendorParamDxBGetSTC,
	OMX_IndexVendorParamDxBSetTSIFReadSize,
	OMX_IndexVendorParamDxBResetVideo,
	OMX_IndexVendorParamDxBResetAudio,
	OMX_IndexVendorParamDxBStartTSCMonitor, //TSC(Transport Scrambling Control bit)
	OMX_IndexVendorParamDxBStopTSCMonitor,
	OMX_IndexVendorParamDxBGetTSCMonitor,
	OMX_IndexVendorParamDxBSetBBType,
	OMX_IndexVendorParamDxBSetBitrate,	
	OMX_IndexVendorParamDxBRegisterCasDecryptCallback,
	OMX_IndexVendorParamDxBSetParentLock,
	OMX_IndexVendorParamDxBStartSectionFilterEx,
	OMX_IndexVendorParamDxBGetSectionHandleEx,
	OMX_IndexVendorParamDxBStopSectionFilterEx,
	OMX_IndexVendorParamDxBStartDemuxing,
	OMX_IndexVendorParamDxBActiveModeSet,
	OMX_IndexVendorParamDxBSendData,
	
	
	
	//for isdbt
	OMX_IndexVendorParamTunerDeviceSet,	
	OMX_IndexVendorParamTunerChannelSearch,
	OMX_IndexVendorParamTunerChannelSet,
	OMX_IndexVendorParamTunerFrequencySet,
	OMX_IndexVendorParamTunerCountryCodeSet,
	OMX_IndexVendorParamTunerGetStartFlag,
	OMX_IndexVendorParamComponentClose,
	OMX_IndexVendorParamDemuxSysInit,
	OMX_IndexVendorParamDemuxSysdeInit,
	OMX_IndexVendorParamDemuxStopRequest,
	OMX_IndexVendorConfigGetEpg,
	OMX_IndexVendorParamTunerGetEWSFlag,
	
	//for dvbt
	OMX_IndexVendorParamTunerChannelSearchStart,
	OMX_IndexVendorParamTunerChannelSearchContinue,
	OMX_IndexVendorParamTunerChannelSearchStop,
	OMX_IndexVendorParamSetPID,
	OMX_IndexVendorParamRemovePID,
	OMX_IndexVendorParamClearPID,
	OMX_IndexVendorConfigSetPID,
	OMX_IndexVendorConfigClearPID,
	OMX_IndexVendorParamSetBroadcastStart,
	OMX_IndexVendorParamSetBroadcastPmtId,
	OMX_IndexVendorParamTunerOpen,
	OMX_IndexVendorParamTunerClose,
	OMX_IndexVendorParamSearchFinish,
	OMX_IndexVendorParamDemuxSearchStart,
	OMX_IndexVendorParamDemuxTunerInfo,
	OMX_IndexVendorParamSetDemuxAudioVideoStreamType,
	OMX_IndexVendorParamSetDemuxAudioVideoPID,
	OMX_IndexVendorParamSetDemuxTeletextPID,
	
	//for dvbh
	OMX_IndexVendorParamGetTunerLock, 
	OMX_IndexVendorParamGetTunerStatistics, 
	OMX_IndexVendorConfigSet_MPE_FEC, 
	OMX_IndexVendorConfigClear_MPE_FEC, 
	
	//for tdmb
	OMX_IndexVendorParamTunerChanneIDSet,
	OMX_IndexVendorParamTunerServiceIDSet,
	OMX_IndexVendorParamTunerEnsembleFreqSet,
	OMX_IndexVendorConfigGetSignalStrength,
	OMX_IndexVendorParamSetResync,
	OMX_IndexVendorParamBroadcastResetdata,
	OMX_IndexVendorConfigVideotoBroadCastFlagSet ,
	OMX_IndexVendorConfigVideoDisableInit,
	OMX_IndexVendorParamTDMBBitrateSet,
	OMX_IndexVendorConfigVideoSeqHeaderReSet,
	OMX_IndexVendorConfigVideoSeqHeaderSucess,
	OMX_IndexVendorConfigResyncCheck,
	OMX_IndexVendorConfigPadParserReInit,
	OMX_IndexVendorParamStopClockCheck,
	OMX_IndexVendorConfigStartRecord,
	OMX_IndexVendorConfigStopRecord,

	//for atsc
	OMX_IndexVendorConfigSearchFrequency,
	OMX_IndexVendorParamGetModulation,
	OMX_IndexVendorParamGetFrequency,
	OMX_IndexVendorParamGetHasDVBSignal,
	OMX_IndexVendorConfigWakeUp, 
	OMX_IndexVendorConfigSetServiceID, 
	OMX_IndexVendorConfigSetServiceType, 
	OMX_IndexVendorConfigSetModulation, 
	OMX_IndexVendorConfigSetFrequency, 
	OMX_IndexVendorConfigSetFrequencyAnalog,
	OMX_IndexVendorConfigSetAudioPID, 
	OMX_IndexVendorConfigSetVideoPID, 
	OMX_IndexVendorConfigSetPCRPID, 
	OMX_IndexVendorConfigSetVideoDecInfo, 
	OMX_indexVendorConfigSetVideoDecInit, 
	OMX_indexVendorConfigSetVideoDecDeinit, 
	OMX_IndexVendorConfigSetVideoScaleInfo, 
	OMX_IndexVendorConfigSetVideoScaleFlush, 
	OMX_IndexVendorConfigSetVideoOutInfo, 
	OMX_IndexVendorConfigSetVideoOutReset, 
	OMX_IndexVendorConfigSetAudioDecInfo, 
	OMX_IndexVendorConfigSetAudioDecReset, 
	OMX_IndexVendorConfigSetAudioOutInfo, 
	OMX_IndexVendorParamSetSleepModeEnable, 
	OMX_IndexVendorParamSetSleepModeDisable, 
	OMX_IndexVendorParamGetSleepMode, 
	OMX_IndexVendorConfigSetAspectRatio,	//20100526 romeo9 : OMX_IndexConfigSetAspectRatio
	OMX_IndexVendorConfigSetAFD,			//20100706 romeo9 : OMX_IndexVendorConfigSetAFD
	OMX_IndexVendorConfigSetTableUpdate,	//20100625 romeo9 : OMX_IndexVendorConfigSetTableUpdate
	OMX_IndexVendorConfigSetAudioLanguage, 
	OMX_IndexVendorConfigSetClosedCaption,
	OMX_IndexVendorConfigResetDemod,
	OMX_IndexVendorConfigRecordStart,
	OMX_IndexVendorConfigRecordStop,
	OMX_IndexVendorConfigDemuxSubSetFilter,  // for dual demux test

	// Section Component
	OMX_IndexVendorConfigSecStandardType, 
	OMX_IndexVendorParamSecRequestTableInfo, 
	// IPDC Component
	OMX_IndexVendorConfig_IPDC_AddFileter, 
	OMX_IndexVendorConfig_IPDC_RemoveFileter, 

	OMX_IndexVendorParamVideoEncSeqHeader,

	// Camera Config Index
	OMX_IndexVendorParamCamera,
	OMX_IndexVendorParamCameraSetNormalDir, 
	OMX_IndexVendorParamCameraSetAccidentDir, 
	OMX_IndexVendorParamCameraSetPreFix, 
	OMX_IndexVendorConfigCamera,
	OMX_IndexVendorConfigExcuteCheck,
	
	//WFD Sink
	OMX_IndexVendorSetHDCPStackInitFunc,
	OMX_IndexVendorSetHDCPDecryptionFunc,
	OMX_IndexVendorSetUSESecuredMemoryForTEE,
	OMX_IndexVendorSetSecureVideoPathMutex,
	OMX_IndexVendorSetWFDBaseTimeReset,
	OMX_IndexVendorSetVideoSenderStart,	
	OMX_IndexVendorSetBufferingMode,
	OMX_IndexVendorSetDisplayDisable,
    OMX_IndexVendorSetVolumeControlEnable,
	OMX_IndexVendorSetVolumeControl,
	OMX_IndexVendorSetVolumeMute,
	OMX_IndexVendorSetPlayerDebugMode,	
	OMX_IndexVendorMax = 0x7FFFFFFF
}TC_OMX_INDEXVENDORTYPE;

typedef enum
{
	OMX_ErrorVendorFileOpenFailed = 0x90000001,
	OMX_ErrorVendorFileCloseFailed,
	OMX_ErrorVendorFileReadFailed,	
	OMX_ErrorVendorMemAllocFailed ,
	OMX_ErrorVendorNoImageData,	
	OMX_ErrorVendorBufferOverflow,
	OMX_ErrorVendorExtDataFailed,
	OMX_ErrorVendorAudioPortParamSettingFailed,
	OMX_ErrorVendorVideoPortParamSettingFailed,	
	OMX_ErrorVendorAppPrivMemAllocFailed ,
	OMX_ErrorVendorComponentLoadingFailed ,
	OMX_ErrorVendorSetupTunnelingFailed ,
	OMX_ErrorVendorComponentExecutingFailed ,
	OMX_ErrorVendorGetOneFrameFailed ,
	OMX_ErrorVendorGetExtIndexFailed ,
	OMX_ErrorVendorGetExtDataFailed ,
	OMX_ErrorVendorSetExtDataFailed ,
	OMX_ErrorVendorPortEnableFailed ,
	OMX_ErrorVendorPortDisableFailed ,
	OMX_ErrorVendorPortFlushFailed	,
	OMX_ErrorVendorTimeRequestFailed,
	OMX_ErrorVendorSemaTimerExpire,
	OMX_ErrorVendorCodecOpenFailed,
	OMX_ErrorVendorCodecCloseFailed,
	OMX_ErrorVendorInvalidInfo,
	OMX_ErrorVendorInvalidFile,
	OMX_ErrorVendorSetOutputFailed,
	OMX_ErrorVendorExtramodeFailed,
	OMX_ErrorVendorAudioCodecOpenFailed,
	OMX_ErrorVendorDecodingFailed,
	OMX_ErrorVendorDMXDataFullError,
	
	// for rec
	OMX_ErrorVendorRecFileOpenFail,
	OMX_ErrorVendorRecFileCloseFail,

	//for image
	OMX_ErrorVendorImageGetOrgSizeFailed,	
	OMX_ErrorVendorImageSetOutWidth,	
	OMX_ErrorVendorImageSetOutHeight,
	OMX_ErrorVendorImageSetThumbOffset,
	OMX_ErrorVendorImageSetOutBufferPointer,
	OMX_ErrorVendorImageSetOutFormat,	

	//for Broadcasting
	OMX_ErrorVendorTDMBFrequencySetFail,	
	OMX_ErrorVendorTDMBServiceSetFail,	
	OMX_ErrorVendorTDMBFrequencySetSuccess,
	OMX_ErrorVendorTDMBTSDataError,	
	OMX_ErrorVendorTDMBWeakSignal, 
	OMX_ErrorVendorTDMBDABDataError, 
	OMX_ErrorVendorTDMBSeqHeaderFail, 
	OMX_ErrorVendorTunerSetFrequencyFail, 

	/*Video*/	
	OMX_ErrorVendorUnsupportedFormat= 0x90001000,
	OMX_ErrorVendorUnsupportedCombination,
	OMX_ErrorVendorUnsupportedVideoCodec,
	OMX_ErrorVendorUnsupportedVideoSize,
	OMX_ErrorVendorUnsupportedVideoFramerate,
	OMX_ErrorVendorUnsupportedAudioCodec,
	OMX_ErrorVendorNoVideoData,
	OMX_ErrorVendorNoAudioData,
	OMX_ErrorVendorDemuxerInitFailed,
	OMX_ErrorVendorDemuxerGetInfoFailed,
	OMX_ErrorVendorDemuxerDeinitFailed,
	OMX_ErrorVendorDemuxerGetStreamFailed,
	OMX_ErrorVendorVPUInitFailed,
	OMX_ErrorVendorVPUMemoryError,
	OMX_ErrorVendorVPUSeqHDRFailed,
	OMX_ErrorVendorCDKInitFailed,
	OMX_ErrorVendorCDKSetIOFailed,
	OMX_ErrorVendorM2MFailed,
	OMX_ErrorVendorG2DFailed,
	OMX_ErrorVendorActualScreenFailed,
	OMX_ErrorVendorCaptureFailed,
	OMX_ErrorVendorNotSupportSubtitle,
	OMX_ErrorVendorTdmbRecorderStart,

	/* Camera */
	OMX_ErrorVendorCameraOpenFail,

	
	OMX_ErrorVendorMax = 0x9000FFFF
}TC_OMX_ERRORVENDORTYPE;

typedef enum{
	STEREO_OUTPUT_MODE = 0,
	MULTI_OUTPUT_MODE
}AUDIO_OUTPUT_TYPE;

typedef enum{
	ALSA_OPEN_SRC = 0,
	ALSA_OPEN_PCM_SRC,
	ALSA_OPEN_NOTSRC,
}ALSA_OPENMODE_TYPE;

typedef enum{
	SUPPORT_AUDIO_CODEC = 0,
	NOT_SUPPORT_AUDIO_CODEC, 
	NO_AUDIO_DATA,
}AUDIO_ERROR_TYPE;

typedef enum OMX_VENDOR_EVENTDATA
{
	OMX_VENDOR_EVENTDATA_BUFFER_CONTROL = 1000,
	OMX_VENDOR_EVENTDATA_SET_AV_CODEC_TYPE,
	OMX_VENDOR_EVENTDATA_SET_PMT_PID,
	OMX_VENDOR_EVENTDATA_TUNER_RESYNC,
	OMX_VENDOR_EVENTDATA_TUNER,
	OMX_VENDOR_EVENTDATA_DEMUX,
	OMX_VENDOR_EVENTDATA_RECORD,
} OMX_VEDOR_EVENT_DATA;

typedef struct
{
	unsigned int uiAudioCodecType;
	unsigned int uiVideoCodecType;

}TCC_DEMUX_ES_STREAM_TYPE;

// extention index_name
#define TCC_AUDIO_FILE_OPEN_STRING "OMX.tcc.index.param.dec.inputfilename"
//#define TCC_AUDIO_FILE_CLOSE_INDEX "OMX.tcc.index.param.fileclose"
#define TCC_AUDIO_MEDIA_INFO_STRING "OMX.tcc.index.config.dec.mediainfo"
#define TCC_AUDIO_POWERSPECTUM_STRING "OMX.tcc.index.config.dec.powerspectrum"
#define TCC_AUDIO_ENERGYVOLUME_STRING "OMX.tcc.index.config.dec.energyvolume"
#define TCC_AUDIO_PARSER_MEDIA_STRING "OMX.tcc.index.param.parser.mediainfo"

#define TCC_AUDIO_DEC_SET_OUTPUT_STRING "OMX.tcc.index.param.dec.output_set"
#define TCC_AUDIO_DEC_SET_DYNAMICRANGE_STRING "OMX.tcc.index.config.dec.dynaminrange_set"

#define TCC_AUDIO_DEQ_ONOFF_STRING "OMX.tcc.index.config.deq.onoff"
#define TCC_AUDIO_DEQ_MODE_STRING "OMX.tcc.index.config.deq.mode"


#define TCC_ENC_SET_BITRATE_STRING "OMX.TCC.index.param.enc.setbitrate"
#define TCC_ENC_SET_FILE_FORMAT_STRING "OMX.TCC.index.param.enc.setfileformat"
#define TCC_ENC_SETFILE_PATH_STRING "OMX.TCC.index.param.enc.setfilepath"
#define TCC_ENC_WRITE_HEADER_DATA_STRING "OMX.TCC.index.param.enc.writeheader"
#define TCC_ENC_END_STRING "OMX.TCC.index.param.enc.end"

#define TCC_BROADCAST_PID_STRING "OMX.tcc.index.config.tuner.setpid"
#define TCC_BROADCAST_SET_MODE_STRING "OMX.tcc.index.param.dec.setmode"
#define TCC_BROADCAST_SET_PMT_ID_STRING "OMX.tcc.index.param.dec.setpmtid"

// for GPIO measurement
// If do you want to check GPIOs for time measurement 
// please eliminate below comments
//#define PERFORMANCE_GPIO_MEASURE_FILEIO
//#define PERFORMANCE_GPIO_MEASURE_DMX
//#define PERFORMANCE_GPIO_MEASURE_VDEC
//#define PERFORMANCE_GPIO_MEASURE_ADEC
//#define PERFORMANCE_GPIO_MEASURE_FBDEV
//#define PERFORMANCE_GPIO_MEASURE_ALSA

#endif /* __TCC_OMX_INDEX_H__ */
